Unit MatrGen;

Interface

Uses MatrDef;

Procedure MCopy(M1,M2:PMatrixF);
{ ஢  }

Procedure GMadd(M1,M2,MR:PMatrixF);
{  ,࠭  饬  }

Procedure GMsub(M1,M2,MR:PMatrixF);
{ ⠭ ,࠭  饬  }

Procedure GMprd(M1,M2,MR:PMatrixF);
{  ,࠭  饬  }

Procedure GMtra(M,MR:PMatrixF);
{ ࠭ᯮ஢ ,࠭饩  饬  }

Procedure Gtprd(M1,M2,MR:PMatrixF);
{ M1^*M2 ࠭  饬  }

Procedure Mprd(M1,M2,MR:PMatrixF);
{   }

Procedure MTra(M,MR:PMatrixF);
{ ࠭ᯮ஢  }

Procedure Tprd(M1,M2,MR:PMatrixF);
{ M1^*M2 }

Procedure Mata(M,MR:PMatrixF);
{ M*M^ }

Implementation

Procedure MCopy(M1,M2:PMatrixF);
{ ஢  }
Var I:word;
Begin
 For I:=1 to M1^.Loc(M1^.Lines,M1^.Cols) do
  M2^.Put(I,M1^.Get(I))
End;

Procedure GMadd(M1,M2,MR:PMatrixF);
{  ,࠭  饬  }
Var I:integer; R:extended;
Begin
 For I:=1 to M1^.Cols*M1^.Lines do begin
  R:=PFloat(M1^.Get(I))^+PFloat(M2^.Get(I))^;
  MR^.Put(I,@R)
 end
End;

Procedure GMsub(M1,M2,MR:PMatrixF);
{ ⠭ ,࠭  饬  }
Var I:integer; R:extended;
Begin
 For I:=1 to M1^.Cols*M1^.Lines do begin
  R:=PFloat(M1^.Get(I))^-PFloat(M2^.Get(I))^;
  MR^.Put(I,@R)
 end
End;

Procedure GMprd(M1,M2,MR:PMatrixF);
{  ,࠭  饬  }
Var I,J,K,IR,J1,IB,IK:integer; A:extended;
Begin
 IR:=0; IK:=-M1^.Cols;
 For K:=1 to M2^.Cols do begin
  Inc(IK,M1^.Cols);
  For J:=1 to M1^.Lines do begin
   Inc(IR); J1:=J-M1^.Lines; IB:=IK;
   A:=0;
   For I:=1 to M1^.Cols do begin
    Inc(J1,M1^.Lines); Inc(IB);
    A:=A+PFloat(M1^.Get(J1))^*PFloat(M2^.Get(IB))^
   end;
   MR^.Put(IR,@A)
  end
 end
End;

Procedure GMtra(M,MR:PMatrixF);
{ ࠭ᯮ஢ ,࠭饩  饬  }
Var I,J,IR,IJ:integer; N:byte;
Begin
 IR:=0; N:=M^.Lines;
 For I:=1 to N do begin
  IJ:=I-N;
  For J:=1 to M^.Cols do begin
   Inc(IJ,N); Inc(IR);
   MR^.Put(IR,M^.Get(IJ))
  end
 end
End;

Procedure Gtprd(M1,M2,MR:PMatrixF);
{ M1^*M2 ࠭  饬  }
Var IR,IJ,IB,K,J,I,IK:integer; N:byte; A:extended;
Begin
 IR:=0; N:=M1^.Lines; IK:=-N;
 For K:=1 to M2^.Cols do begin
  IJ:=0; Inc(IK,N);
  For J:=1 to M1^.Cols do begin
   IB:=IK; Inc(IR);
   A:=0;
   For I:=1 to N do begin
    Inc(IJ); Inc(IB);
    A:=A+PFloat(M1^.Get(IJ))^*PFloat(M2^.Get(IB))^
   end;
   MR^.Put(IR,@A)
  end
 end
End;

Procedure Mprd(M1,M2,MR:PMatrixF);
{   }
Var I,K,J,IR,IA,IB:integer; R:extended;
Begin
 If (M1^.GetMatrixType=DiagM) and (M2^.GetMatrixType=DiagM) then
  For I:=1 to M1^.Lines do begin
   R:=PFloat(M1^.Get(I))^*PFloat(M2^.Get(I))^;
   MR^.Put(I,@R)
  end
 else begin
  IR:=1;
  For  K:=1 to M2^.Cols do
   For J:=1 to M1^.Lines do begin
    R:=0;
    MR^.Put(IR,@R);
    For I:=1 to M1^.Cols do begin
     If (M1^.GetMatrixType+M2^.GetMatrixType)=0 then begin
      IA:=M1^.Lines*(I-1)+J;
      IB:=M1^.Cols*(K-1)+I
     end
     else begin
      IA:=M1^.Loc(J,I);
      IB:=M2^.Loc(I,K);
      If (IB=0) or (IA=0) then continue
     end;

     R:=PFloat(MR^.Get(IR))^+PFloat(M1^.Get(IA))^*PFloat(M2^.Get(IB))^;
     MR^.Put(IR,@R);
    end;
    Inc(IR)
   end
  end
End;

Procedure MTra(M,MR:PMatrixF);
{ ࠭ᯮ஢  }
Var I,J,IR,IJ:integer; N:byte;
Begin
 If M^.GetMatrixType<>GeneralM then MCopy(M,MR)
 else begin
  N:=M^.Lines;
  IR:=0;
  For I:=1 to N do begin
   IJ:=I-N;
   For J:=1 to M^.Cols do begin
    Inc(IJ,N); Inc(IR);
    MR^.Put(IR,M^.Get(IJ))
   end
  end
 end
End;

Procedure Tprd(M1,M2,MR:PMatrixF);
{ M1^*M2 }
Var  I,J,K,IR,IA,IB:integer; R:extended;
Begin
 If (M1^.GetMatrixType=DiagM) and (M2^.GetMatrixType=DiagM) then
  For I:=1 to M1^.Lines do begin
   R:=PFloat(M1^.Get(I))^*PFloat(M2^.Get(I))^;
   MR^.Put(I,@R)
  end

 else begin
  IR:=1;
  For K:=1 to M2^.Cols do
   For J:=1 to M1^.Cols do begin
    R:=0;
    MR^.Put(IR,@R);
    For I:=1 to M1^.Lines do begin
     If (M1^.GetMatrixType+M2^.GetMatrixType)=0 then begin
      IA:=M1^.Lines*(J-1)+I;
      IB:=M1^.Lines*(K-1)+I
     end
     else begin
      IA:=M1^.Loc(I,J);
      IB:=M2^.Loc(I,K);
      If (IB=0) or (IA=0) then continue;
     end;

     R:=PFloat(MR^.Get(IR))^+PFloat(M1^.Get(IA))^*PFloat(M2^.Get(IB))^;
     MR^.Put(IR,@R);
    end;
    Inc(IR)
   end
 end
End;

Procedure Mata(M,MR:PMatrixF);
{ M*M^ }
Label 1;
Var K,I,J:byte; KX,IR,IA,IB:word; R:extended;
Begin
 For K:=1 to M^.Cols do begin
  KX:=(Sqr(K)-K) div 2;
  For J:=1 to M^.Cols do
   If J<=K then begin
    IR:=J+KX;
    R:=0;
    MR^.Put(IR,@R);
    For I:=1 to M^.Lines do begin
     If M^.GetMatrixType=GeneralM then begin
      IA:=M^.Lines*(J-1)+I;
      IB:=M^.Lines*(K-1)+I;
      goto 1
     end;
     IA:=M^.Loc(I,J);
     IB:=M^.Loc(I,K);
     If IA<>0 then
1:
      If IB<>0 then begin
       R:=PFloat(MR^.Get(IR))^+PFloat(M^.Get(IA))^*PFloat(M^.Get(IB))^;
       MR^.Put(IR,@R)
      end
    end
   end
 end
End;


End.
