{$C DemandLoad,Discardable}
{$S 0}
Unit RZACalc;

Interface
Uses UserFunc,UstrDB,Prog2x2,EnRZA,EnDlg,EnTr;

Procedure RZAReport(Rep:PReport);

Implementation
Uses WinAPI,MyString,TPDate,Calcer,App,Objects,Views,Drivers,EnerDef,
     PXEngine,EnDict,EnSelRep,Def2x2,MatrDef,Diffy,PriError,EnPsp,EnPasp,
     MyValids,Dialogs,Validate,Dos,MsgBox,Menus;

Const
 iwDate=8;
 iwTime=5;
 iwLong=9;
 iwFloat=15;
 iwText=30;

Var
 BInfo:PBrowseInfo;
 ShStrCount:byte;
 ShapkaNeed:boolean;
 TblShapka:PStrMatrix;
 Fir:word; { ᫮ - }

Type
 TGetPrintCod=function(What:word):string;
 TPrintCodPar=function(What:word; Par:byte):string;
 TGetNCodes=function:word;
 TGetCodeName=function(Cod:word):string;

 PRZACompilator=^TRZACompilator;
 TRZACompilator=object(TCompilator)
  Funcs:array[1..100] of PCalcer;
  LLoc,DLoc:RecordNumber;
  StrPrinted:string;
  F,Fpr:Text;
  PrintedLines:word;
  CurPage:word;
  PrinterHandle:THandle;
  PrintSetup:string[100];
  NoPrint:boolean;
  constructor Init;
  destructor Done;virtual;
  procedure GetDataString(Var S:string);virtual;
  procedure FlushPrintLine;virtual;
  procedure Print(Var S:string);virtual;
  function ReadDB:boolean;
 end;

 PfGetDates=^fGetDates;
 fGetDates=object(TUserProc)       { GetDates(Var D1,D2:Date) }
  D1,D2:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfGetPeriod=^fGetPeriod;
 fGetPeriod=object(TUserStrFunc)   { string=Period(D1,D2:Date) }
  D1,D2:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfGetNRecs=^fGetNRecs;            { error=GetNRecs/ReadRec }
 fGetNRecs=object(TUserFunc)
  Wh:byte;
  constructor Init(AWhat:byte);
  procedure Evaluate;virtual;
 end;

 PfGotoRec=^fGotoRec;              { error=GotoRec(word) }
 fGotoRec=object(TUserFunc)
  NR:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfGetDateTime=^fGetDateTime;
 fGetDateTime=object(TUserFunc)    { Date/Time=WorkDate/WorkTime/ }
  What:byte;                                 { VvodDate/MakeDate  }
  constructor Init(AWhat:byte);              { Today/CurTime      }
  procedure Evaluate;virtual;
 end;

 PfGetDictName=^fGetDictName;
 fGetDictName=object(TUserStrFunc) { string=Stupen/KZ/Ocenka }
  What:byte;                       { string=Station/...      }
  constructor Init(AWhat:byte);
  procedure Evaluate;virtual;
 end;

 PfGetDBPar=^fGetDBPar;
 fGetDBPar=object(TUserStrFunc)    { string=Zavod/InvNom/ZavNom }
  What:byte;                       { string=PspFld(Index:word) }
  D:PFloat;
  constructor Init(AWhat:byte);
  procedure Evaluate;virtual;
 end;

 PfGetDictCode=^fGetDictCode;
 fGetDictCode=object(TUserFunc)    { word=Cod(What:word) }
  Cod:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfPageSetup=^fPageSetup;          { PageSetup(w1,w2,w3,w4:word) }
 fPageSetup=object(TUserProc)
  D1,D2,D3,D4:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfDateToDMY=^fDateToDMY;
 fDateToDMY=object(TUserProc)      { DateToDMY(D:Date; Var d,m,y:word) }
  D1,D2,D3,D4:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfDMYToDate=^fDMYToDate;
 fDMYToDate=object(TUserFunc)      { Date=DMYToDate(d,m,y:word) }
  D1,D2,D3:PFloat;                 { word=ValidDate(d,m,y:word) }
  What:byte;
  constructor Init(AWhat:byte);
  procedure Evaluate;virtual;
 end;

 PfPrinterSetup=^fPrinterSetup;
 fPrinterSetup=object(TUserProc)   { PrinterSetup(string) }
  D1:PText;                        { MsgBox(string)       }
  Wh:word;
  constructor Init(AWhat:word);
  procedure Evaluate;virtual;
 end;

 PfPrichina=^fPrichina;
 fPrichina=object(TUserProc)       { Prichina(Var array of string) }
  PM:Ppointer;
  Count:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfSplitAr=^fSplitAr;
 fSplitAr=object(TUserProc)
  PM:Ppointer;
  ACount,MaxLen,NewCount:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfGetPasp=^fGetPasp;              { error=Passport(Var array of str; }
 fGetPasp=object(TUserFunc)        {                Var word)         }
  PM:Ppointer;                     { word=Menu(array of str,word)     }
  N:PFloat;
  What:word;
  constructor Init(AWhat:word);
  procedure Evaluate;virtual;
 end;

 PfGetUF=^fGetUF;
 fGetUF=object(TUserProc)          { Maska(Var array of string; }
  PM,PN:Ppointer;                  {      (Var array of word)   }
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfIzmerTbl=^fIzmerTbl;
 fIzmerTbl=object(TUserFunc)       { word=IzmerTbl(Var array of string) }
  PM:Ppointer;
  Pr1,Pr2:PText;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfSetShapka=^fSetShapka;
 fSetShapka=object(TUserProc)      { SetShapka(array of string; Count:word) }
  Count:PFloat;
  PS:Ppointer;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfBeginTable=^fBeginTable;        { BeginTable/EndTable/NewPage }
 fBeginTable=object(TUserProc)
  What:byte;
  constructor Init(AWhat:byte);
  procedure Evaluate;virtual;
 end;

 PfInput=^fInput;
 fInput=object(TUserFunc)
  PMWhats,PMTitles,PMValues:Ppointer;
  Count:PFloat;
  Title:PText;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PDInp=^TDInp;
 TDInp=object(TKDialog)
  IL:array[1..15] of PInputLine;
  Wh:array[1..15] of word;
  Values:PStrMatrix;
  Count:word;
  constructor Init(Bounds:TRect; ACount:word; const Ttl:string;
   TMaxLen,DMaxLen:byte;
   AWhats:PMatrix; ATitles,AValues:PStrMatrix);
  function Valid(Command:Word):boolean; virtual;
  function Translate(Var Y:integer):boolean;
 end;

 PfGetDicts=^fGetDicts;             { error=GetDicts(                  }
 fGetDicts=object(TUserFunc)        {                Var word)         }
  AIndex,AName,AIndex1,AIndex2:Ppointer;
  What,Count:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 PfFindDict=^fFindDict;          {  }
 fFindDict=object(TUserFunc)
  What,Index,Ind1,Ind2:PFloat;
  Nme:PText;
  constructor Init;
  procedure Evaluate;virtual;
 end;

Var
 RZAComp:PRZACompilator;
 GetNCodes:TGetNCodes;
 GetCodeName:TGetCodeName;
 GetPrintCod:TGetPrintCod;
 PrintCodPar:TPrintCodPar;

Constructor fInput.Init;
Begin
 Inherited Init('INPUT',5,0,False);
 Title:=InsertStrPar(False);
 Count:=InsertFloatPar(False);
 PMWhats:=InsertArrayPar;
 PMTitles:=InsertStrArrayPar;
 PMValues:=InsertStrArrayPar;
End;

Procedure fInput.Evaluate;
Var Cnt,W,W1,W2,I,K:word; Ttl:string; P:PDInp; R:TRect; Res:extended;
    S:string; Titles,Values:PStrMatrix; Whats:PMatrix; Sp:pointer;
Begin
 Res:=1;
 SetResult(@Res);

 Cnt:=Round(Count^);
 If (Cnt>0) and (Cnt<=15) then begin
  Ttl:=Title^;
  W:=MinI(10+byte(Ttl[0]),80); { ਭ    Title }

  Titles:=PStrMatrix(PMTitles^);
  Values:=PStrMatrix(PMValues^);
  Whats:=PMatrix(PMWhats^);

  W1:=0; W2:=0;
  For I:=1 to Cnt do begin
   Sp:=Titles^.Get(I);
   If byte(Sp^)>20 then byte(Sp^):=20;
   If byte(Sp^)>W1 then W1:=byte(Sp^); { max ਭ  }

   K:=Round(extended(Whats^.Get(I)^));
   Case K of { max ਭ   }
    iwDate,iwTime,iwLong,iwFloat,iwText: W2:=MaxI(W2,K)
    else exit
   end;
  end;

  Inc(W2,2); K:=2+W1+2+W2+2; K:=MaxI(K,W);

  R.Assign(0,0,K,Cnt+4);
  New(P,Init(R,Cnt,Ttl,W1,W2,Whats,Titles,Values));
  K:=DeskTop^.ExecView(P); Dispose(P,Done);
  If K=cmOK then Res:=0
 end;
 SetResult(@Res);
End;

Constructor TDInp.Init(Bounds:TRect; ACount:word; const Ttl:string;
   TMaxLen,DMaxLen:byte;
   AWhats:PMatrix; ATitles,AValues:PStrMatrix);
Var S:string; I,K,Y:word; V:PValidator;
Begin
 Inherited Init(Bounds,Ttl);
 Options:=Options or ofCentered;
 HelpCtx:=hcInputDate;

 Count:=ACount; Values:=AValues;
 Y:=2;

 For I:=1 to ACount do begin
  S:=PString(ATitles^.Get(I))^;
  K:=Round(extended(AWhats^.Get(I)^));
  Wh[I]:=K;

  Case K of
   iwDate: V:=New(PPXPictureValidator,Init('##/[##/[##]]',True));
   iwTime: V:=New(PPXPictureValidator,Init('##/##]',True));
   iwLong: V:=New(PFilterValidator,Init(['0'..'9','-']));
   iwFloat:V:=New(PFloatValidator,Init(-1e-10,1e10));
   iwText: V:=nil;
  end;

  Bounds.Assign(TMaxLen+4,Y,TMaxLen+K+6,Y+1);
  IL[I]:=New(PInputLine,Init(Bounds,K));
  With IL[I]^ do begin
   Options:=Options or ofValidate; Validator:=V;
   SetData(AValues^.Get(I)^);
  end;
  Insert(IL[I]);

  Bounds.Assign(1,Y,2+TMaxLen,Y+1);
  Insert(New(PLabel,Init(Bounds,S,IL[I])));
  Inc(Y)
 end;
 SelectNext(False);
End;

Function TDInp.Translate(Var Y:integer):boolean;

 Function GetTime(Var St:string; Var T:word):boolean;
 Var I1,I2:byte; cod:integer;
 Begin
  GetTime:=False;
  Val(Copy(St,1,2),I1,cod);
  If (I1>24) then exit;
  Val(Copy(St,4,2),I2,cod);
  If I2>60 then exit;
  T:=I2 or (I1 shl 8);
  GetTime:=True
 end;

 Function GetDate(Var St:string; Var RD:RDate):boolean;
 Var I1,I2:byte; cod:integer; S:string[20]; Len:byte absolute S;
 Begin
  S:=St;
  With RD do begin
   If S[Len]='/' then Dec(byte(S[0]));
   I1:=CharPos('/',S);
   I2:=LastCharPos('/',S);
   If I1<>I2 then begin { 뤥塞  }
    Val(Copy(S,1,2),D,cod);
    System.Delete(S,1,3)
   end;
   If I1<>0 then begin { 뤥塞  }
    Val(Copy(S,1,2),M,cod);
    System.Delete(S,1,3)
   end;
   Val(S,Y,cod);
   If ((I1=0) or (I1=I2)) and (D<>1) then D:=DaysInMonth(M,Y+1900)
   else
    If D>DaysInMonth(M,Y+1900) then D:=DaysInMonth(M,Y+1900)
  end;
 end;

Var S:string[50]; RD:RDate; T,I:word; D:Date;
Begin
 Translate:=False;
 For I:=1 to Count do begin
  Y:=I;
  IL[I]^.GetData(S);
  FastTrim(S);
  If (S='') and (Wh[I]<>iwText) then exit;

  Case Wh[I] of
   iwDate: begin
    With RD do begin D:=1; M:=1; end;
    GetDate(S,RD);
    D:=DMYtoDate(RD.D,RD.M,RD.Y);
    S:=DateToDateString('dd/mm/yy',D);
   end;
   iwTime: begin
    If not GetTime(S,T) then exit;
   end;
   iwLong,iwFloat,iwText:;
  end;
  Values^.Put(I,@S)
 end;
 Translate:=True;
End;

Function TDInp.Valid(Command:word):boolean;
Var B:boolean; Y:integer;
Begin
 Valid:=True;
 If Command=cmOK then begin
  Valid:=False;
  B:=Inherited Valid(cmOK);
  If B then begin
   B:=Translate(Y);
   If not B then IL[Y]^.Select else Valid:=True
  end
 end
End;

Constructor fGetDates.Init;
Begin
 Inherited Init('GETDATES',2,2);
 D1:=InsertFloatPar(True); D2:=InsertFloatPar(True);
End;

Procedure fGetDates.Evaluate;
Var Res:extended; P:PFloat;
Begin
 D1^:=word(BInfo^.Date1); D2^:=word(BInfo^.Date2);
End;

Constructor fGetDBPar.Init(AWhat:byte);
Const Ns:array[1..4] of string[6]=('ZAVOD','INVNOM','ZAVNOM','PSPFLD');
Begin
 Inherited Init(Ns[AWhat],byte(AWhat=4),0,False);
 What:=AWhat;
 If AWhat=4 then D:=InsertFloatPar(False);
End;

Procedure fGetDBPar.Evaluate;
Var Res:string; B:boolean; I,K:word; Er:integer; RP:RPasp; Ps:PPassport;
Begin
 If What=4 then B:=True
 else begin
  B:=BInfo^.MDBRead;
  If not B and (BInfo^.What<>wrUstr) then B:=RZAComp^.ReadDB;
 end;

 If B then With BInfo^.UR do
   Case What of
    1:Res:='';
    2:Res:=InvNumber;
    3:Res:=ZavNumber;
    4:begin
     Res:='';
     If BInfo^.DBRead then With BInfo^ do begin
      While True do begin
       If (PspColl=nil) or (CurPspMarka<>Pd^.Marka) then begin
        If TPaspTbl=0 then begin
         OpenTPasp(Er);
         If Er<>0 then break;
        end;
        If PspColl<>nil then begin Dispose(PspColl,Done); PspColl:=nil; end;

        GetTPaspColl(Pd^.Marka,PCollection(PspColl),Er);
        If (Er<>0) or (PspColl^.Count=0) then break;
        CurPspMarka:=Pd^.Marka;
       end;

       If PaspTbl=0 then begin
        OpenPasp(Er);
        If Er<>0 then break
       end;

       RP.Station:=Pd^.Station; RP.Prisoed:=Pd^.Prisoed;
       RP.DispName:=Pd^.DispName;
       ReadPsp(RP,Er);
       If Er<>0 then break;

       K:=Round(D^);
       For I:=1 to RP.HeadSize do
        If RP.DataDesc[I].Index=K then begin
         Res:=RP.Data[I];
         Ps:=PspColl^.ExistIndex(RP.DataDesc[I].Index);
         If (Ps<>nil) and (Res<>'') then begin
          If byte(Ps^.FldType)>6 then
           GetDictName(byte(Ps^.FldType)-6,StrToWord(Res),Er,Res);
         end
         else Res:=''
        end;
       break
      end;
     end
    end;
   end
 else Res:='';
 SetResult(@Res)
End;

Constructor fGetPeriod.Init;
Begin
 Inherited Init('PERIOD',2,0,False);
 D1:=InsertFloatPar(False); D2:=InsertFloatPar(False);
End;

Procedure fGetPeriod.Evaluate;
Var Res:string; RD1,RD2:RDate;
Begin
 DateToDMY(Date(Round(D1^)),integer(RD1.D),integer(RD1.M),integer(RD1.Y));
 DateToDMY(Date(Round(D2^)),integer(RD2.D),integer(RD2.M),integer(RD2.Y));
 Res:=DatePeriod(RD1,RD2);
 SetResult(@Res)
End;

Constructor fGetNRecs.Init(AWhat:byte);
Var S:string[20];
Begin
 If AWhat=1 then S:='GETNRECS' else S:='READREC';
 Inherited Init(S,0,0,False);
 Wh:=AWhat
End;

Procedure fGetNRecs.Evaluate;
Var Res:extended; N:RecordNumber; Buff:array[1..50] of word;
Begin
 If Wh=1 then begin
  BInfo^.Error:=PXTblNRecs(BInfo^.LTbl,N);
  If BInfo^.Error<>0 then Res:=0 else Res:=longint(N);
 end
 else begin
  BInfo^.DBRead:=False; BInfo^.MDBRead:=False;
  With BInfo^ do begin
   If BInfo^.What<>wrUstr then { ⠥  .롮ન  }
    Error:=PXRecGet(LTbl,LRH)
   else Error:=0;
   If Error=0 then begin
    If What<>wrUstr then Error:=PXRawGet(LRH,Buff,100);
    Case What of
     wrUstr:begin
      ReadDBRec(@UR,BInfo^.LTbl,LRH,Error);
      MDBRead:=Error=0;
      If Error=0 then With Pd^ do begin
       Station:=UR.Station; Prisoed:=UR.Prisoed;
       Marka:=UR.Marka; DispName:=UR.UstrName
      end
     end;

     wrJournal:begin
      { 頥  .- ୠ  饬 ⠬ ⠪ - }
      Error:=PXRawPut(RZARecHandle,Buff,100);
      Error:=PXSrchKey(RZATbl,RZARecHandle,5,SearchFirst);
      If Error=0 then ReadRZARec(RJ,Error);
     end;

     wrTra:begin
      { 頥  .- ⠭  饬 ⠬ ⠪ - }
      Error:=PXRawPut(TraRecHandle,Buff,100);
      Error:=PXSrchKey(TraTbl,TraRecHandle,5,SearchFirst);
      If Error=0 then ReadTraRec(TR,Error);
     end
    end;
    DBRead:=Error=0;
   end
  end;
  Res:=BInfo^.Error;
 end;
 SetResult(@Res)
End;

Constructor fGotoRec.Init;
Begin
 Inherited Init('GOTOREC',1,0,False);
 NR:=InsertFloatPar(False);
End;

Procedure fGotoRec.Evaluate;
Var Res:extended; N:longint;
Begin
 N:=Round(NR^);
 BInfo^.Error:=PXRecGoto(BInfo^.LTbl,RecordNumber(N));
 Res:=BInfo^.Error;
 SetResult(@Res)
End;

Constructor fGetUF.Init;
Begin
 Inherited Init('MASKA',2,0);
 PM:=InsertStrArrayPar;
 PN:=InsertArrayPar;
End;

Procedure fGetUF.Evaluate;
Var Res:extended; I,K,J:word; S:string[50]; M:PStrMatrix; M1:PMatrix;
Begin
 M:=PStrMatrix(PM^);
 M1:=PMatrix(PN^);

 K:=MinI(M^.Lines,MinI(8,M1^.Lines));

 For I:=1 to K do With BInfo^ do begin
  S:=UF[I].Name;
  M^.Put(I,@S);
  Res:=UF[I].Index;
  M1^.Put(I,@Res)
 end;
End;

Constructor fFindDict.Init;
Begin
 Inherited Init('FINDDICT',5,3,False);
 What:=InsertFloatPar(False);
 Index:=InsertFloatPar(False);
 Nme:=InsertStrPar(True);
 Ind1:=InsertFloatPar(True);
 Ind2:=InsertFloatPar(True);
End;

Const WD:array[1..7] of byte=(wdPodr,wdFactory,wdStation,wdClass,
 wdPrisoed,wdUstr,wdMarka);

Procedure fFindDict.Evaluate;
Var Res:extended; W:word; Er:integer; DR:DictRec;
Begin
 W:=Round(What^);
 Case W of
  1..7: begin
   GetDictRec(WD[W],Round(Index^),Er,DR);
   If Er=0 then begin
    Nme^:=DR.Name;
    Ind1^:=DR.Sop1; Ind2^:=DR.Sop2;
   end
  end;
  else Er:=-1
 end;
 Res:=Er; SetResult(@Res)
End;

Constructor fGetDicts.Init;
Begin
 Inherited Init('GETDICT',6,1,False);
 What:=InsertFloatPar(False);
 Count:=InsertFloatPar(True);
 AIndex:=InsertArrayPar;
 AName:=InsertStrArrayPar;
 AIndex1:=InsertArrayPar;
 AIndex2:=InsertArrayPar;
End;

Procedure fGetDicts.Evaluate;
Var Res:extended; I,W,Cnt:word; Er:integer; Coll:PDictColl; P:PDictRec;
    AIndexes,AIndexes1,AIndexes2:PMatrix; ANames:PStrMatrix;
Begin
 ANames:=PStrMatrix(AName^);
 AIndexes:=PMatrix(AIndex^);
 AIndexes1:=PMatrix(AIndex1^);
 AIndexes2:=PMatrix(AIndex2^);
 W:=Round(What^);
 Case W of
  1..7: GetDColl(WD[W],Coll,Er,nil,False);
  else Er:=-1
 end;
 If Er<>0 then Cnt:=0
 else begin
  Cnt:=Coll^.Count;
  If Cnt>AIndexes^.Lines then AIndexes^.NewSize(Cnt,1);
  If Cnt>AIndexes1^.Lines then AIndexes1^.NewSize(Cnt,1);
  If Cnt>AIndexes2^.Lines then AIndexes2^.NewSize(Cnt,1);
  If Cnt>ANames^.Lines then ANames^.NewSize(Cnt,MaxI(27,ANames^.StrLen-1));

  For I:=1 to Cnt do begin
   P:=Coll^.At(I-1);
   Res:=P^.Index; AIndexes^.Put(I,@Res);
   Res:=P^.Sop1; AIndexes1^.Put(I,@Res);
   Res:=P^.Sop2; AIndexes2^.Put(I,@Res);
   ANames^.Put(I,@P^.Name);
  end;
 end;
 If Er>=0 then Dispose(Coll,Done);
 Res:=Er; SetResult(@Res);
 Count^:=Cnt
End;

Constructor fGetPasp.Init(AWhat:word);
Var S:string[8];
Begin
 If AWhat=1 then S:='PASSPORT' else S:='MENU';
 Inherited Init(S,2,byte(AWhat=1),False);
 PM:=InsertStrArrayPar;
 N:=InsertFloatPar(AWhat=1);
 What:=AWhat;
End;

Procedure fGetPasp.Evaluate;
Var Res:extended; I,K,Cm,MLen,L:word; Er,X0,Y0:integer; S:string[50]; R:TRect;
    RP:RPasp; M:PStrMatrix; MB:PMenuBox; P,Q:PMenuItem; Ps:PPassport;
Begin
 M:=PStrMatrix(PM^);

 If What=1 then begin
  N^:=0; S:='';
  For I:=1 to M^.Lines do M^.Put(I,@S);

  If BInfo^.DBRead then With BInfo^ do begin
   While True do begin
    If (PspColl=nil) or (CurPspMarka<>Pd^.Marka) then begin
     If TPaspTbl=0 then begin
      OpenTPasp(Er);
      If Er<>0 then begin Res:=-3; break end;
     end;
     If PspColl<>nil then begin Dispose(PspColl,Done); PspColl:=nil; end;

     GetTPaspColl(Pd^.Marka,PCollection(PspColl),Er);
     If Er<>0 then begin Res:=-3; break end;
     If PspColl^.Count=0 then begin Res:=-1; break end;
     CurPspMarka:=Pd^.Marka;
    end;

    If PaspTbl=0 then begin
     OpenPasp(Er);
     If Er<>0 then begin Res:=-3; break end;
    end;

    RP.Station:=UR.Station; RP.Prisoed:=UR.Prisoed;
    RP.DispName:=UR.UstrName;
    ReadPsp(RP,Er);
    Case Er of
     0:;
     PXErr_RecNotFound: begin Res:=-2; break end;
     else begin Res:=-3; break end;
    end;

    N^:=0; L:=0;
    For I:=1 to MinI(M^.Lines,RP.HeadSize) do begin
     S:=RP.Data[I];
     Ps:=PspColl^.ExistIndex(RP.DataDesc[I].Index);
     If Ps<>nil then begin
      Inc(L);
      If (S<>'') and (byte(Ps^.FldType)>6) then
       GetDictName(byte(Ps^.FldType)-6,StrToWord(S),Er,S);
      M^.Put(L,@S)
     end
    end;
    N^:=L;
    Res:=0;
    break
   end
  end
 end
 else
 While True do begin
  Res:=0; MLen:=0;
  K:=Round(N^);
  If K>23 then K:=23 else If K<2 then break;
  P:=NewItem(Pstring(M^.Get(K))^,'',0,8000+K,hcRec,nil);

  For I:=K-1 downto 1 do begin
   S:=Pstring(M^.Get(I))^;
   MLen:=MaxI(MLen,byte(S[0]));
   Q:=NewItem(S,'',0,8000+I,hcRec,P);
   P:=Q
  end;

  X0:=(ScreenWidth-MLen) div 2;
  Y0:=(ScreenHeight-K) div 2;
  R.Assign(X0,Y0,X0+MLen,X0+K);
  MB:=New(PMenuBox,Init(R,NewMenu(P),nil));
  Cm:=PopupMenu(MB);
  DisposeMenu(MB^.Menu); Dispose(MB,Done);
  If Cm>0 then Dec(Cm,8000);
  Res:=Cm;
  break
 end;
 SetResult(@Res)
End;

Constructor fGetDateTime.Init(AWhat:byte);
Const Ns:array[1..6] of string[8]=(
 'WORKDATE','WORKTIME','VVODDATE','MAKEDATE','TODAY','CURTIME');
Begin
 Inherited Init(Ns[AWhat],0,0,False);
 What:=AWhat
End;

Procedure fGetDateTime.Evaluate;
Var Res:extended; B:boolean; D:Date; Hours:word;
Begin
  Case What of
   1: With BInfo^.Pd^ do Res:=longint(DMYtoDate(Day,Month,Year));
   2: With BInfo^.Pd^ do Res:=word(Min or (Hour shl 8));
   3..4: With BInfo^.Pd^ do begin
    B:=BInfo^.MDBRead;
    If not B then B:=RZAComp^.ReadDB;
    If B then
     If What=3 then Res:=BInfo^.UR.InDate
     else Res:=BInfo^.UR.MakeDate
    else Res:=BadDate;
   end;
   5:begin D:=Today; Res:=word(D); end;
   6:begin
      asm
       mov ah,2ch
       int 21h
       mov Hours,cx
      end;
      Res:=Hours
     end
  end;
 SetResult(@Res)
End;

Constructor fGetDictCode.Init;
Begin
 Inherited Init('COD',1,0,False);
 Cod:=InsertFloatPar(False);
End;

Procedure fGetDictCode.Evaluate;
Var Res:extended; C,I:word;
Begin
 C:=Round(Cod^);
 I:=0;

 If BInfo^.DBRead then
  With BInfo^.Pd^ do
   Case C of
    1: I:=GetSecondDict(wdFactory,GetSecondDict(wdStation,Station));
    2: I:=GetSecondDict(wdStation,Station);
    3: I:=Station;
    4: I:=GetSecondDict(wdPrisoed,Prisoed);
    5: I:=Prisoed;
    6: I:=GetSecondDict(wdMarka,Marka);
    7: I:=Marka;
   end;
 Res:=I;
 SetResult(@Res)
End;

Const
 Ns:array[1..8] of string[8]=(
  'ENSYSTEM','OWNER','STATION','CLASS','PRISOED','USTRTYPE','MARKA',
  'USTR');

Constructor fGetDictName.Init(AWhat:byte);
Const
 Ns1:array[21..23] of string[8]=('STUPEN','KZ','OCENKA');
Var S:string[15];
Begin
 Case AWhat of
  1..8:   S:=Ns[AWhat];
  21..23: S:=Ns1[AWhat];
  30:     S:='PERSONAL';
 end;
 Inherited Init(S,0,0,False);
 What:=AWhat
End;

Procedure fGetDictName.Evaluate;
Var Res:string; I:word; E:integer;
Begin
 If BInfo^.DBRead then
 With BInfo^.Pd^ do
  Case What of
   1:begin
      I:=GetSecondDict(wdStation,Station); { 稫 Factory }
      GetDictName(wdPodr,GetSecondDict(wdFactory,I),BInfo^.Error,Res);
     end;
   2: GetDictName(wdFactory,GetSecondDict(wdStation,Station),BInfo^.Error,Res);
   3: GetDictName(wdStation,Station,BInfo^.Error,Res);
   4: GetDictName(wdClass,GetSecondDict(wdPrisoed,Prisoed),BInfo^.Error,Res);
   5: GetDictName(wdPrisoed,Prisoed,BInfo^.Error,Res);
   6: GetDictName(wdUstr,GetSecondDict(wdMarka,Marka),BInfo^.Error,Res);
   7: GetDictName(wdMarka,Marka,BInfo^.Error,Res);
   8: Res:=DispName;
   21: If RzDs[rzStep]=0 then Res:='' { Stupen }
       else GetDictName(FirstUser+rzStep,RzDs[rzStep],E,Res);
   22: If RzDs[rzKZ]=0 then Res:='' { KZ }
       else GetDictName(FirstUser+rzKZ,RzDs[rzKZ],E,Res);
   23: If RzDs[rzOW]=0 then Res:='' { Ocenka }
       else GetDictName(FirstUser+rzOW,RzDs[rzOW],E,Res);
   24,25:;
   30: Res:=Pers;
  end
 else Res:='?';
 SetResult(@Res)
End;

Constructor fIzmerTbl.Init;
Begin
 Inherited Init('IZMERTBL',3,2,False);
 PM:=InsertStrArrayPar;
 Pr1:=InsertStrPar(True); Pr2:=InsertStrPar(True);
End;

Procedure fIzmerTbl.Evaluate;
Var Res:extended; Lens,Lines,J,I:word; St:string; M:PStrMatrix;
Begin
 M:=PStrMatrix(PM^);
 If BInfo^.DBRead then
 With BInfo^.TR.DataTbl do begin
  Lens:=Len and $00FF;
  Lines:=Len shr 8;
  J:=0;
  St[0]:=char(Lens);
  Pr1^:=Prim[0]; Pr2^:=Prim[1];

  For I:=1 to Lines do begin
   FastMove(BInfo^.TR.DataTbl.Buf[J],St[1],Lens);
   M^.Put(I,@St);
   Inc(J,Lens)
  end;
 end
 else Lines:=0;

 Res:=Lines;
 SetResult(@Res);
 St:='';
 { ⮪ -  窨 }
 For I:=Lines+1 to M^.Lines do M^.Put(I,@St);
End;

Constructor fPageSetup.Init;
Begin
 Inherited Init('PAGE',4,0);
 D1:=InsertFloatPar(False); D2:=InsertFloatPar(False);
 D3:=InsertFloatPar(False); D4:=InsertFloatPar(False);
End;

Procedure fPageSetup.Evaluate;
Var He,W,N,M:word;
Begin
 He:=Round(D1^); W:=Round(D2^); N:=Round(D3^); M:=Round(D4^);
 If N>2 then N:=2;
 With BInfo^ do begin
  PageH:=He; PageW:=W; Numeration:=N; LMargin:=M;
 end;
End;

Constructor fDMYToDate.Init(AWhat:byte);
Var S:string[10];
Begin
 If AWhat=1 then S:='DMYTODATE' else S:='VALIDDATE';
 Inherited Init(S,3,0,False);
 D1:=InsertFloatPar(False); D2:=InsertFloatPar(False);
 D3:=InsertFloatPar(False);
 What:=AWhat
End;

Procedure fDMYToDate.Evaluate;
Var D:word; Res:extended;
Begin
 Case What of
  1: D:=DMYToDate(Round(D1^),Round(D2^),Round(D3^));
  2: D:=byte(ValidDate(Round(D1^),Round(D2^),Round(D3^)));
 end;
 Res:=D;
 SetResult(@Res)
End;

Constructor fDateToDMY.Init;
Begin
 Inherited Init('DATETODMY',4,3);
 D1:=InsertFloatPar(False); D2:=InsertFloatPar(True);
 D3:=InsertFloatPar(True); D4:=InsertFloatPar(True);
End;

Procedure fDateToDMY.Evaluate;
Var D:word; Day,M,Y:integer;
Begin
 D:=Round(D1^);
 DateToDMY(D,Day,M,Y);
 D2^:=Day; D3^:=M; D4^:=Y
End;

Constructor fPrinterSetup.Init(AWhat:word);
Var S:string[15];
Begin
 If AWhat=1 then S:='PRINTERSETUP' else S:='MESSAGE';
 Inherited Init(S,1,0);
 D1:=InsertStrPar(False);
 Wh:=AWhat;
End;

Procedure fPrinterSetup.Evaluate;
Begin
 If Wh=2 then MessageBox(Pstring(D1)^,nil,mfOKButton+mfInformation)
 else
  If not IsShift then RZAComp^.PrintSetup:=D1^;
End;

Constructor fSplitAr.Init;
Begin
 Inherited Init('SPLITAR',4,1);
 PM:=InsertStrArrayPar;
 ACount:=InsertFloatPar(False);
 MaxLen:=InsertFloatPar(False);
 NewCount:=InsertFloatPar(True);
End;

Procedure fSplitAr.Evaluate;
Var M:PStrMatrix; AC,NC,Sz,Cn,I,ML,J:word; S,St,S1:string;
    NAr:array[1..30] of string[80]; Per:byte; B:boolean;
Begin
 M:=PStrMatrix(PM^);
 Sz:=M^.Lines;
 AC:=Round(ACount^);
 ML:=Round(MaxLen^);
 I:=1; J:=0; St:='';

 While (I<=AC) do begin
   S:=PString(M^.Get(I))^;

   While True do begin
    Repeat
     B:=SplitString(S,St,ML,Per);
     If B and (I<AC) then begin
      Inc(I);
      S1:=PString(M^.Get(I))^;
      FastTrimHead(S1);
      S:=S+' '+S1;
     end
     else B:=False;
    until not B;
    Inc(J);
    NAr[J]:=RPad(S,ML);
    If St='' then break else S:=St
   end;
   Inc(I);
 end;

 If J>Sz then J:=Sz;
 S:=FillStr(' ',ML);
 For I:=J+1 to Sz do NAr[I]:=S;
 For I:=1 to Sz do M^.Put(I,@NAr[I]);

 NewCount^:=J;
End;

Constructor fPrichina.Init;
Begin
 Inherited Init('PRICHINA',2,1);
 PM:=InsertStrArrayPar;
 Count:=InsertFloatPar(True);
End;

Procedure fPrichina.Evaluate;
Var M:PStrMatrix; Sz,Cn,I,K,L:word; S:string;
Begin
 M:=PStrMatrix(PM^);
 Sz:=M^.Lines;
 K:=0; Cn:=0;

 With BInfo^.RJ.Prich do begin
  If Len>0 then begin
   L:=Len+2; Buf[Len+1]:=#13; Buf[L]:=#10
  end
  else L:=Len;
  While (K<L) and (Cn<=Sz) do begin
   I:=0;
   While Buf[I+K]<>#10 do Inc(I);
   S[0]:=char(I-1);
   Move(Buf[K],S[1],I-1);
   Inc(K,I+1);
   Inc(Cn);
   M^.Put(Cn,@S);
  end
 end;
 Count^:=Cn;
End;

Constructor fSetShapka.Init;
Begin
 Inherited Init('SETSHAPKA',2,0);
 PS:=InsertStrArrayPar;
 Count:=InsertFloatPar(False);
End;

Procedure fSetShapka.Evaluate;
Begin
 ShStrCount:=Round(Count^);
 TblShapka:=pointer(PS^);
End;

Constructor fBeginTable.Init(AWhat:byte);
Var S:string[10];
Begin
 Case AWhat of
  1:S:='BEGINTABLE';
  2:S:='ENDTABLE';
  3:S:='NEWPAGE';
  4:S:='NOPRINT';
 end;
 Inherited Init(S,0,0);
 What:=AWhat
End;

Procedure fBeginTable.Evaluate;
Var S:string[10];
Begin
 If RZAComp^.NoPrint then exit;
 Case What of
  3:With RZAComp^ do begin
   If StrPrinted<>'' then writeln(F,StrPrinted);
   StrPrinted:='';
   If PrintedLines<>0 then begin
    PrintedLines:=0;
    writeln(F,#12);
    Inc(CurPage)
   end
  end;
  4: RZAComp^.NoPrint:=True;
  else ShapkaNeed:=What=1;
 end
End;

Constructor TRZACompilator.Init;
Const
 Sh2:array[1..5] of string[7]=('IWDATE','IWTIME','IWLONG','IWREAL','IWTEXT');
 Sh2V:array[1..5] of word=(8,5,9,15,30);
Var I:byte; S:string[13]; Sl:PChar;
Begin
 Inherited Init;
 PrinterHandle:=0;
 PrintSetup:='';
 NoPrint:=False;
 Fir:=0;
 BInfo^.PspColl:=nil;

 { 騥 - }
 Funcs[1]:=New(PfPageSetup,Init);
 Funcs[2]:=New(PfSplitAr,Init);
 Funcs[3]:=New(PfSetShapka,Init);
 Funcs[4]:=New(PfBeginTable,Init(1));   { BeginTbl }
 Funcs[5]:=New(PfBeginTable,Init(2));   { EndTbl }
 Funcs[6]:=New(PfPrinterSetup,Init(1));
 Funcs[7]:=New(PfBeginTable,Init(3));   { NewPage }
 Funcs[8]:=New(PfInput,Init);
 Funcs[9]:=New(PfGetDateTime,Init(5));  { Today }
 Funcs[10]:=New(PfGetDateTime,Init(6)); { CurTime }
 Funcs[11]:=New(PfDateToDMY,Init);
 Funcs[12]:=New(PfDMYToDate,Init(1));   { DMYToDate }
 Funcs[13]:=New(PfDMYToDate,Init(2));   { ValidDate }
 Funcs[14]:=New(PfBeginTable,Init(4));  { NoPrint }
 Funcs[15]:=New(PfPrinterSetup,Init(2));{ Meassage }
 Funcs[16]:=New(PfGetPasp,Init(2));     { Menu     }
 Funcs[17]:=New(PfGetDicts,Init);       { GetDict  }
 Funcs[18]:=New(PfFindDict,Init);       { FindDict }
 Fir:=19;

 If BInfo^.What<>3 then begin {  騩 }
  Funcs[Fir]:=New(PfGetPasp,Init(1)); {   ᯮ }
  Funcs[Fir+1]:=New(PfGetUF,Init); {   ᪥ 롮ન }
  Inc(Fir,2);
  For I:=1 to 4 do Funcs[Fir+I-1]:=New(PfGetDBPar,Init(I));
  If BInfo^.What<>wrUstr then begin { ,६ ७/ࠡ뢠 }
   For I:=1 to 4 do Funcs[Fir+I+3]:=New(PfGetDateTime,Init(I));
   Inc(Fir,8);
  end
  else begin
   For I:=1 to 2 do Funcs[Fir+I+3]:=New(PfGetDateTime,Init(I+2));
   Inc(Fir,6);
  end;

  If BInfo^.What<>wrUstr then begin
   { - ਮ }
   Funcs[Fir]:=New(PfGetDates,Init);
   Funcs[Fir+1]:=New(PfGetPeriod,Init);
   Inc(Fir,2);
  end;

  { - ⥭  }
  Funcs[Fir]:=New(PfGetNRecs,Init(1));
  Funcs[Fir+1]:=New(PfGotoRec,Init);
  Funcs[Fir+2]:=New(PfGetNRecs,Init(2));
  Inc(Fir,3);

  { - ᫮ }
  For I:=1 to 8 do Funcs[Fir+I-1]:=New(PfGetDictName,Init(I));
  Funcs[Fir+8]:=New(PfGetDictCode,Init);
  Inc(Fir,9);

  Case BInfo^.What of
   wrJournal:begin
    { - -ୠ 権 }
    For I:=21 to 23 do Funcs[(I-21)+Fir]:=New(PfGetDictName,Init(I));
    Funcs[Fir+3]:=New(PfGetDictName,Init(30));
    Funcs[Fir+4]:=New(PfPrichina,Init);
    Inc(Fir,4);
   end;
   wrTra:begin
    Funcs[Fir]:=New(PfIzmerTbl,Init);
   end;
   wrUstr: Dec(Fir);
  end;
  For I:=1 to 7 do AddUserConst('C'+Ns[I],I);
 end
 else Dec(Fir);

 For I:=1 to 7 do AddUserConst('D'+Ns[I],I);
 For I:=1 to 5 do AddUserConst(Sh2[I],Sh2V[I]);
 For I:=1 to Fir do AddFunction(PUserFunc(Funcs[I]));

 { 㦠 ࠩ ਭ }
 If IsShift then Sl:='NULPR.DRV'
 else begin
  S:=EnDBIni.PrinterType+#0; Sl:=PChar(@S[1])
 end;
 PrinterHandle:=LoadLibrary(Sl);
 If PrinterHandle=0 then Fail;

 @GetNCodes:=GetProcAddress(PrinterHandle,PChar(1));
 @GetCodeName:=GetProcAddress(PrinterHandle,PChar(2));
 @GetPrintCod:=GetProcAddress(PrinterHandle,PChar(3));
 @PrintCodPar:=GetProcAddress(PrinterHandle,PChar(4));
 If (@GetPrintCod=nil) or (@PrintCodPar=nil) or
    (@GetNCodes=nil) or (@GetCodeName=nil) then Fail;

 For I:=1 to GetNCodes do begin
  S:=GetPrintCod(I); AddUserStrConst(GetCodeName(I),S)
 end;

 If BInfo^.What<>3 then With BInfo^ do begin
  {   . - ன }
  PXRecNum(LTbl,LLoc);
  If DBTbl<>0 then PXRecNum(LTbl,DLoc);
 end;

 { 뢠 䠩 ணࠬ  १ }
 Assign(F,'reports.out\'+BInfo^.Rep^.FileRes);
 Rewrite(F);
 If IsError then Fail;
 Assign(Fpr,'reports\'+BInfo^.Rep^.File2x2);
 Reset(Fpr);
 If IsError then Fail;

 StrPrinted:='';
 PrintedLines:=0;
 CurPage:=1;
 ShapkaNeed:=False;

 { - ࠭  㬮砭 }
 BInfo^.PageH:=66; BInfo^.PageW:=80; BInfo^.Numeration:=1;
End;

Destructor TRZACompilator.Done;
Var I:byte;
Begin
 For I:=1 to Fir do Dispose(Funcs[I],Done);
 If BInfo^.What<>3 then With BInfo^ do begin
  { ⠭  . - ன }
  PXRecGoto(LTbl,LLoc);
  If DBTbl<>0 then PXRecGoto(LTbl,DLoc);
 end;
 Close(F);
 Close(Fpr);
 If PrinterHandle<>0 then FreeLibrary(PrinterHandle);
 If BInfo^.PspColl<>nil then Dispose(BInfo^.PspColl,Done);
 Inherited Done
End;

Procedure TRZACompilator.Print(Var S:string);
Begin
 StrPrinted:=StrPrinted+S;
{  writeln(StrPrinted);readln;
 end}
End;

Procedure TRZACompilator.FlushPrintLine;
Var I:byte;
 Procedure PageNum;
 Begin
  writeln(F,CenterStr('-'+Long2Str(CurPage)+'-',BInfo^.PageW,' '));
  writeln(F);
  Inc(PrintedLines,2);
 end;
Begin
 If NoPrint then exit;
 If PrintedLines=0 then begin
  If (CurPage=1) and not IsShift then
   {If EnDBIni.PrinterType=ptDot then write(F,#27'l',chr(BInfo^.LMargin))
   else write(F,#27'&a',chr(BInfo^.LMargin),'L', #27'&l26A');}
   write(F,PrintSetup,PrintCodPar(62,BInfo^.LMargin));

  If BInfo^.Numeration>0 then
   If (CurPage=1) then
    If (BInfo^.Numeration=1) then PageNum else
   else PageNum;
  If ShapkaNeed and (ShStrCount<BInfo^.PageH) then begin
   For I:=1 to ShStrCount do writeln(F,Pstring(TblShapka^.Get(I))^);
   Inc(PrintedLines,ShStrCount);
  end;
 end;

 {writeln(StrPrinted);readln;}
 writeln(F,StrPrinted);
 StrPrinted:='';
 Inc(PrintedLines);

 If (BInfo^.PageH>0) and (PrintedLines>=BInfo^.PageH)  then begin
  writeln(F,#12);
  PrintedLines:=0;
  Inc(CurPage);
 end;
End;

Function TRZACompilator.ReadDB:boolean;
{   ⥭   .ன⢠  .⥢  }
Begin
 With BInfo^ do begin
  FindRec(pointer(Pd),EnerDef.DBTbl,DBRecHandle,Error);
  If Error=0 then ReadDBRec(@UR,EnerDef.DBTbl,DBRechandle,Error);
  MDBRead:=Error=0;
  ReadDB:=MDBRead;
 end
End;

Procedure TRZACompilator.GetDataString(Var S:string);
Begin
 If Eof(Fpr) then EOFData:=True else readln(Fpr,S)
End;

Function GetOwner(What:byte; Var BrOwner:RBrowseInfo):pointer;
Var P:pointer; Cm:word;
Begin
 Case What of
  wrUstr: Cm:=cmGetUstrPars;
  wrJournal,wrTra: Cm:=cmGetJrnlPars;
 end;
 P:=Message(DeskTop,evBroadcast,Cm,@BrOwner);
 GetOwner:=P;
End;

Procedure RZAReport(Rep:PReport);
Var BI:RBrowseInfo;  Line,Col:integer; S:string[80]; B:boolean;
Begin
 BI.What:=Rep^.What; {  祬 ⭮  }
 BI.TrWhat:=Rep^.TrWhat; {  ७ }
 If Rep^.What<>3 then { 饬   롮મ  塞 BI }
  If GetOwner(Rep^.What,BI)=nil then exit;
 BI.Rep:=Rep;
 BI.DBRead:=False; { True, ᫨ - ReadRec  ।  롮ન }
 BI.MDBRead:=False; { True, ᫨ ⠭  .  }
 BI.Error:=0;
 Case BI.What of  { 㪠⥫   롮ન }
  wrJournal,wrUstr: BI.Pd:=@BI.RJ;
  wrTra           : BI.Pd:=@BI.TR.Station;
 end;

 BInfo:=@BI;
 New(RZAComp,Init);
 If RZAComp=nil then exit;

 RZAComp^.Translate;
 If (CompError.Error=0) and (RZAComp^.TransError=0) then begin
  RZAComp^.Evaluate;
  B:=not RZAComp^.NoPrint;
  Dispose(RZAComp,Done);
  If B then EditProgram('reports.out\'+BI.Rep^.FileRes,0,0,'');
 end
 else begin
  Line:=RZAComp^.ErrorY;
  Col:=RZAComp^.ErrorX;
  S:='訡 '+Long2Str(RZAComp^.TransError)+': '+
   RezStr^.Get(s2x2Er+RZAComp^.TransError);
  Dispose(RZAComp,Done);
  EditProgram('reports\'+BI.Rep^.File2x2,Col-1,Line-1,S);
 end
End;

End.
