{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
{$C DemandLoad,Discardable}
Unit ExprComp;
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses Calcer,X1,Def2x2,Hash2x2,TPInline,Diffy,UserFunc,MatrDef,Objects;

{$DEFINE UseDirect}

Type
 IdHandle=PHashCell;

 POutVar=^TOutVar;
 TOutVar=record
  HVar:PHashCell;
  Diff:boolean;
  Expo:boolean;
  F1,F2:byte
 end;

 PIdDef=^TIdDef;
 TIdDef=record
  Name:PText;
  Value:PFloat;
  Res:byte;
  Expo:boolean;
  F1,F2:byte
 end;

 PListColl=^TListColl;
 TListColl=object(TCollection)
  procedure FreeItem(Item:pointer);virtual;
 end;

 PExprCompilator=^TExprCompilator;
 TExprCompilator=object(TACompilator) {  ࠦ }
  EOFData:boolean;         { ਧ                      }
  CurY:word;               { ⥪騩  ப              }
  DataStr:string;
  ATerms:array[boolean] of TToken;  { ⠡ ᥬ                 }
  ContainPar:boolean;      { ਧ  ࠬ஢              }
  ErrorX,ErrorY:word;      {  訡                        }
  TransError:integer;      {  訡                              }
  StandHash:PStandardHash; {  १. ᫮                         }
  GlobalHash:PTermHash;    { .  ( Var,Par,UserFunc )           }
  CHash:PTermHash;         { ⥪騩     }
  CurTerm:boolean;         { ⥪騩    }

  { 㦥 ६ }
  FutureStrError:word;     {  訡  TransStrExpression   }
  FutureError:word;        {  訡  TransExpression      }
  TopTerm:PToken;
  IsDiff:boolean;
  NCalcs:word;             { ⥪. ᫮ . 権              }
  NLogCalcs:word;          { ⥪. ᫮ . 権                }
  NBraL:word;              { ⥪. ᫮ ᪮ (),-  logic-- }
  NBraE:word;              { ⥪. ᫮ ᪮ (),-  .- }
  NBrack:word;             { ⥪. ᫮ . ᪮ []             }
  JumpPoint:JumpRecord;
  ParInExpr:boolean;       { ⥪. ਧ  ࠬ஢         }
  ExNeed:boolean;          { ⥪. ਧ 㦭 -; 㦭, ᫨ }
                           { ᮤন Par,DoubleVar,Array,Polinom,UserFunc }
  ParList:PListColl;
  {ErrorTxt:TermString;}
  ErrorData:longint;

  constructor Init;
  procedure GetDataString(Var S:string);virtual;
  procedure InitHash;virtual;
  procedure MapError(Var Xe,Ye:word);virtual;

  function AddString(Name:string):IdHandle;
  function AddParametr(Name:string):IdHandle;
  function AddUserConst(Name:string; Value:Float):boolean;
  function AddUserStrConst(Name:string; Value:string):boolean;
  function AddFunction(F:PUserFunc):IdHandle;
  function AddProcedure(F:PUserProc):IdHandle;
  function AddArray(Name:string; What:FArrayType; M:PMatrix):IdHandle;
  function AddUserType(Name:string; TypeId:TUserVarType):word;
  function AddUserTypeVar(Name:string; TypeId:TUserVarType):IdHandle;
  function AddDirectCall(WhatCall:TSubrType; Name:TermString; ParCount:word;
   const Pars:TDirectCallPars; Return2x2:TReturnType; ReturnPas:TPasReturnType;
   FuncAddress:pointer; IsSimplified:boolean):boolean;

  function GetIdData(IH:IdHandle):pointer;
  function GetParNums:word;
  function GetParDesc(Num:integer; Var IdDef:TIdDef):boolean;

  function NewString(Var S:string; IsConst:boolean):PText;
  procedure TranslateString(Var P:TExpression);
  function TranslateExpression(PlusSearch,Back:boolean):PTermTree;
  function TranslateStrExpression(Back:boolean):PTermTree;
  procedure ErrorJump(CheckEnd:integer; Xe,Ye:word; Error:word);
  procedure TranslateMath(Var P:TExpression; IsFunc:boolean);
  function TranslateLogic(LogSearch,Back:boolean):PLogicTree;
  destructor Done; virtual;
  procedure GetTerm;
 private
  ErrorLevel:byte;       { ஢ 室  訡 teBraFromLogic }
  Len:byte;
  CurStPos:byte;
  CurSpecial:boolean;
  SpecialWhat:byte;
  LastTree:PTermTree;    { -  ࠡ⪥ teBraFromLogic }
  UserConst:word;
  SubrList:PCollection;  { ᯨ᮪ ணࠬ  ᨢ - }
  function AddConstant(Var V:extended):pointer;
  function AddTerm(P:PToken; Var N:string):PHashCell;
  function NewTerm:PToken;
  procedure TranslateFunc(T:PTermTree; IsFunc,IsDirect:boolean);
  function TranslateRelation:PBoolExpression;
 end;

function AddNewFunc(Count:word; Defs:pointer; Compilator:PExprCompilator):word;

Implementation
Uses {$IFDEF UseDirect} StrD2x2 {$ELSE} StrFuncs {$ENDIF};

Type

 PfResize=^fResize;
 fResize=object(TUserProc)
  PM:Ppointer;
  L,C:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

Constructor fResize.Init;
Begin
 Inherited Init('RESIZE',3,0);
 PM:=InsertAnyArrayPar;
 L:=InsertFloatPar(False); C:=InsertFloatPar(False);
End;

Procedure fResize.Evaluate;
Var M:PMatrix;
Begin
 M:=PMatrix(PM^);
 M^.NewSize(Round(L^),Round(C^))
End;

function AddNewFunc(Count:word; Defs:pointer; Compilator:PExprCompilator):word;assembler;
var _ds,_si,CntRes:word;
asm
 mov CntRes,0
 mov dx,ds
 lds si,Defs
@2:
 lodsw
 push ax      { ⨯ }
 mov al,[si]  {   }
 push ds      {   }
 push si
 xor ah,ah
 add si,ax    { ய᪠  }
 inc si
 lodsw
 push ax      { - - }
 mov bx,3
 push ds      {  ⥫ - }
 push si
 mul bl       { ய⨬ ⥫ }
 add si,ax

 mov cx,4     { ⨯ + - }
@1:
 lodsw
 push ax
 loop @1

 lodsb
 xor ah,ah
 push ax     { IsSimplified }

 mov _ds,ds
 mov _si,si

 lds si,Compilator
 push ds
 push si
 mov ds,dx
 call TExprCompilator.AddDirectCall
 or al,al
 je @exit
 inc CntRes
 mov ax,Count
 cmp ax,CntRes
 je @exit
 mov dx,ds
 mov ax,_ds
 mov ds,ax
 mov si,_si
 jmp @2
@exit:
 mov ax,CntRes
end;

Procedure TListColl.FreeItem(Item:pointer);
Begin
 Dispose(POutVar(Item))
End;

Constructor TExprCompilator.Init;
Var T:PToken;
Begin
 Inherited Init;
 CurTerm:=True;
 SubrList:=New(PCollection,Init(100,100));
 InitHash;

 TransError:=0;
 ContainPar:=False;
 EOFData:=False;
 Len:=0;
 CurStPos:=1;
 CurY:=0;
 NBraL:=0;
 ErrorLevel:=0;
 CurCompilator:=@Self;
 FutureError:=teEndExpected;
 ParList:=New(PListColl, Init(5,5));

 T:=NewTerm;
 With T^ do begin
  TermType:=opNull;
  X:=1; Y:=1; TermLen:=0;
 end;
End;

Procedure TExprCompilator.InitHash;
var Proc1:PCalcer;
Begin
 StandHash:=New(PStandardHash,Init(@Self,nil));
 GlobalHash:=New(PTermHash,Init(@Self,nil));
 CHash:=GlobalHash;
 {$IFDEF UseDirect}
 RegisterStrFuncs(@Self);
 {$ELSE}
 RegisterStrFuncs(StandHash); { 塞 ப - }
 {$ENDIF};
 AddUserConst('PI',Pi); {  ⠭ Pi }
 {  -  ࠧ ᨢ }
 Proc1:=New(PfResize,Init); AddFunction(PUserFunc(Proc1));
End;

Destructor TExprCompilator.Done;
Begin
 Dispose(StandHash,Done);
 Dispose(GlobalHash,Done);
 Dispose(ParList,Done);
 Dispose(SubrList,Done);
 Inherited Done;
End;

Procedure TExprCompilator.GetDataString(Var S:string);
Begin End;

Function TExprCompilator.AddConstant(Var V:extended):pointer;
Var P:PFloat;
Begin
 P:=NewMem(SizeOf(Float));
 P^:=V;
 AddConstant:=P
End;

Function TExprCompilator.NewTerm:PToken;
Begin
 CurTerm:=not CurTerm;
 NewTerm:=@ATerms[CurTerm];
End;

Function TExprCompilator.AddTerm(P:PToken; Var N:string):PHashCell;
Var H:PHashCell;
Begin
 If StandHash^.Find(N,H) or CHash^.Search(N,True,AllMask,H) then begin
  P^.TermType:=H^.TermType;
  P^.TermWhat:=H^.What;
 end
 else begin
  H^.TermType:=opNewVar;
  P^.TermType:=H^.TermType;
 end;
 AddTerm:=H
End;

Function TExprCompilator.AddDirectCall(WhatCall:TSubrType; Name:TermString;
 ParCount:word; const Pars:TDirectCallPars; Return2x2:TReturnType;
 ReturnPas:TPasReturnType; FuncAddress:pointer; IsSimplified:boolean):boolean;
var F:PFunction; H:PHashCell; N1,N2,N3,N4,i,ifi,ife,iftmp,il,b:word;
    DC:PDirectCall;
begin
 AddDirectCall:=False;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;
 If StandHash^.Search(Name,True,AllMask,H) then begin
  TransError:=teResword; exit; { ⠪  㦥  }
 end;

 F:=NewMem(SizeOf(TFunction));
 With F^ do begin
  FuncName:=H;
  NPars:=ParCount;
  NParVars:=0; EnableAssign:=0;
 end;

 N1:=0; N2:=0; N3:=0; N4:=0;

 With H^ do begin
  WhatD:=F;
  If WhatCall=wcProc then begin
   TermType:=opDirectProc;
   IsSimplified:=False
  end
  else begin
   If Return2x2=rtFloat then begin
    TermType:=opDirectFunc;
    Inc(N2); {  ⥫  - }
   end
   else begin
    TermType:=opDirectStrFunc;
    Inc(N3,2); {  㪠-  ப-१ }
    Inc(N1);   {  ⥫ ।   ப }
   end
  end
 end;

 b:=0;

 For i:=1 to ParCount do with Pars[i], F^.Pars[i] do begin
  Hash:=NewMem(SizeOf(THashCell));
  case ParType of
   dctFloat:
    If ByValue then begin
     TermType:=opVar; Inc(b)
    end
    else TermType:=opPar;
   dctString:
    If ByValue then begin
     TermType:=opStringVar; Inc(b)
    end
    else TermType:=opStringPar;
   dctAnyArray: TermType:=opAnyArrVar;
   dctArray   : TermType:=opArrayVar;
   dctStrArray: TermType:=opStrArrVar;
   dctUserType1..dctUserType2: TermType:=ParType+UserTypeVarDelta;
  end;
  Hash^.TermType:=TermType;

  Inc(N1); { ࠧ TCallPrepare }
  case PascalType of
   pptByte..pptPointer,pptDouble:
    If not ByValue then Inc(N2); { ࠧ AfterReturns }
  end;
  { - ࠧ CallStack }
  If not ByValue then begin
   Inc(N3,2);
   case PascalType of
    pptByte..pptInt: Inc(N4);
    pptWord..pptPointer: Inc(N4,2);
    pptDouble: Inc(N4,4)
   end
  end
  else
   case PascalType of
    pptByte..pptWord: Inc(N3);
    pptLong,pptPointer,pptString,pptArray: Inc(N3,2);
    pptDouble: Inc(N3,4);
    pptExtended: Inc(N3,5);
   end
 end;

 il:=N1+N2;
 { ।塞 TDirectCall }
 DC:=NewMem(SizeOf(TDirectCall)+(N3-1)*SizeOf(TDirectStack));
 F^.FuncCalc:=DC;
 with DC^ do begin
  TemplatePrep:=NewMem(il*SizeOf(TCallPrepare));
  TmpAr:=NewMem(N4*SizeOf(word));
  FuncAdr:=FuncAddress
 end;

 { 塞 TemplatePrep }
 ifi:=N1; ife:=N3*2; iftmp:=0;

 If (WhatCall=wcFunc) and (Return2x2=rtString) then
  with DC^.TemplatePrep^[ParCount] do begin
   Dec(ife,4);  { ।   ࠧ pointer }
   ToOfs:=ife;  { ᬥ饭  CallStack }
   What:=word(pctP2P) { pointer->pointer }
  end;

 For i:=1 to ParCount do
  with Pars[i], DC^.TemplatePrep^[i-1] do begin
   case PascalType of
    pptByte..pptInt: begin
     If ByValue then begin
      What:=word(pctE2I); { extended->int }
      Dec(ife,2); { ।   ࠧ word }
     end
     else begin
      {  맮 - }
      Dec(ife,4); { ।   ࠧ pointer }
      What:=word(pctPE2I); { extended->word->^word }
      Aux:=@DC^.TmpAr^[iftmp];
      Inc(iftmp);    { ᤢ  ᫮ }
      longint(From):=ifi;
      { ᫥ 맮 - }
      DC^.TemplatePrep^[ifi].Aux:=Aux;
      DC^.TemplatePrep^[ifi].What:=word(pctI2E);
      Inc(ifi);
     end;
    end;
    pptWord..pptPointer:begin
     If (PascalType=pptWord) and ByValue then Dec(ife,2) { ।   ࠧ word }
     else Dec(ife,4); { ।   ࠧ longint }
     If ByValue then
      If PascalType=pptWord then What:=word(pctE2W) { extended->word }
      else What:=word(pctE2L) { extended->longint }
     else begin
      {  맮 - }
      What:=word(pctPE2L); { extended->longint->^longint }
      Aux:=@DC^.TmpAr^[iftmp];
      Inc(iftmp,2);    { ᤢ  longint }
      longint(From):=ifi;
      { ᫥ 맮 - }
      DC^.TemplatePrep^[ifi].Aux:=Aux;
      DC^.TemplatePrep^[ifi].What:=word(pctL2E);
      Inc(ifi);
     end
    end;
    pptDouble:begin
     If ByValue then begin
      What:=word(pctE2D); { extended->double }
      Dec(ife,8) { ।   ࠧ double }
     end
     else begin
      {  맮 - }
      Dec(ife,4); { ।   ࠧ pointer }
      What:=word(pctPE2D); { extended->double->^double }
      Aux:=@DC^.TmpAr^[iftmp];
      Inc(iftmp,4);    { ᤢ  double }
      longint(From):=ifi;
      { ᫥ 맮 - }
      DC^.TemplatePrep^[ifi].Aux:=Aux;
      DC^.TemplatePrep^[ifi].What:=word(pctD2E);
      Inc(ifi);
     end
    end;
    pptExtended:begin
     If ByValue then begin
      What:=word(pctE2E); { extended->extended }
      Dec(ife,10) { ।   ࠧ extended }
     end
     else begin
      What:=word(pctP2P); { pointer->pointer }
      Dec(ife,4); { ।   ࠧ pointer }
      longint(From):=-1;
     end
    end;
    pptString:begin
     Dec(ife,4);  { ।   ࠧ pointer }
     What:=word(pctP2P) { pointer->pointer }
    end;
    pptArray:begin
     Dec(ife,4);  { ।   ࠧ pointer }
     What:=word(pctPP2P) { ^pointer->pointer }
    end;
   end;
   ToOfs:=ife; { ᬥ饭  CallStack }
  end;

 If (WhatCall=wcFunc) and (Return2x2=rtFloat) then
  with DC^.TemplatePrep^[ifi] do What:=word(ReturnPas) or $100;

 F^.SimpleIfAllConst:=IsSimplified and (b=ParCount);

 with DC^ do begin
  CallStackSize:=N3;
  PrepareSize:=N1;
  AfterPrepare:=N2
 end;
 AddDirectCall:=True
end;

Function TExprCompilator.AddParametr(Name:string):IdHandle;
Var H:PHashCell; OV:POutVar;
Begin
 AddParametr:=nil;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;

 If StandHash^.Find(Name,H) then TransError:=teResword
 else
  If GlobalHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
  else begin
   H^.TermType:=opPar;
   AddParametr:=H;
   New(OV);
   With OV^ do begin
    HVar:=H;
    Diff:=False; Expo:=False;
    F1:=stFormat1; F2:=stFormat2
   end;
   ParList^.Insert(OV);
  end
End;

Function TExprCompilator.AddUserConst(Name:string; Value:Float):boolean;
Var H:PHashCell; OV:POutVar;
Begin
 AddUserConst:=False;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;
 If StandHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
 else begin
  H^.TermType:=opUserConst;
  H^.Value:=Value;
  AddUserConst:=True;
 end
End;

Function TExprCompilator.AddUserStrConst(Name:string; Value:string):boolean;
Var H:PHashCell; OV:POutVar;
Begin
 AddUserStrConst:=False;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;
 If StandHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
 else begin
  H^.TermType:=opStringVar;
  H^.ValueP:=NewString(Value,True);
  AddUserStrConst:=True;
 end
End;

Function TExprCompilator.AddUserType(Name:string; TypeId:TUserVarType):word;
Var H:PHashCell;
Begin
 AddUserType:=0;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;
 If StandHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
 else begin
  H^.TermType:=TypeId;
  AddUserType:=TypeId;
 end
End;

Function TExprCompilator.AddUserTypeVar(Name:string; TypeId:TUserVarType):IdHandle;
Var H:PHashCell;
Begin
 AddUserTypeVar:=nil;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;
 If StandHash^.Find(Name,H) then TransError:=teResword
 else
  If GlobalHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
  else begin
   H^.TermType:=TypeId+UserTypeVarDelta;
   AddUserTypeVar:=H
  end
End;

Function TExprCompilator.AddString(Name:string):IdHandle;
Var H:PHashCell;
Begin
 AddString:=nil;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;
 If StandHash^.Find(Name,H) then TransError:=teResword
 else
  If GlobalHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
  else begin
   H^.TermType:=opStringPar;
   H^.ValueP:=NewMem(TextTermSize);
   AddString:=H
  end
End;

Function TExprCompilator.AddFunction(F:PUserFunc):IdHandle;
Begin
 SubrList^.Insert(F);
 If F^.Register(StandHash) then AddFunction:=F^.H else AddFunction:=nil
End;

Function TExprCompilator.AddProcedure(F:PUserProc):IdHandle;
Begin
 AddProcedure:=AddFunction(PUserFunc(F))
End;

Function TExprCompilator.AddArray(Name:string; What:FArrayType; M:PMatrix):IdHandle;
const C:array[FArrayType] of OpsType=(opArrayVar,opStrArrVar);
Var H:PHashCell; S:PStructDef;
Begin
 AddArray:=nil;
 SubrList^.Insert(M);
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;

 If StandHash^.Find(Name,H) then TransError:=teResword
 else
  If GlobalHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
  else begin
   H^.TermType:=C[What];
   S:=NewMem(SizeOf(TStructDef));
   H^.WhatD:=S;
   S^.Data:=M;
   S^.NameHash:=H;
   AddArray:=H
  end;
End;

Function TExprCompilator.GetIdData(IH:IdHandle):pointer;
Begin
 Case IH^.TermType of
  opPar,opUserVar1..opUserVar2: GetIdData:=@IH^.Value; { PFloat }
  opStringPar: GetIdData:=IH^.ValueP; { PText  }
  else GetIdData:=nil
 end
End;

Procedure TExprCompilator.GetTerm;
Var t,Iold,K,L:byte; Op:OpsType; cod:integer; S:TextTerm;
    Value:extended; TermName:TermString;
Begin
 L:=CurStPos;
 While L>Len do begin
  Inc(CurY);
  GetDataString(DataStr);
  If EOFData then begin
   TopTerm:=NewTerm;
   TopTerm^.TermType:=opEndData;
   With ATerms[not CurTerm] do begin
    TopTerm^.X:=X+TermLen; TopTerm^.Y:=Y
   end;
   exit
  end;

  Len:=Pos('//',DataStr);
  If Len=0 then Len:=Length(DataStr) else Dec(Len);
  While (Len>0) and (DataStr[Len]<=#32) do Dec(Len);
  L:=1;
  DataStr[0]:=chr(Len);
  CurSpecial:=True;
 end; { while }

 While DataStr[L]<=#32 do Inc(L);
 Iold:=L;
 If CurSpecial then
  While (L<=Len) and (IsSpecial(DataStr[L],SpecialWhat)=False) do Inc(L);

 TopTerm:=NewTerm;

 If L=Iold then begin { ᯥ.ᨬ }
  CurSpecial:=True;
  Op:=SpecialChars[SpecialWhat].SType;
  t:=SpecialChars[SpecialWhat].What;

  If (L<Len) and (SpecialWhat>scRBrack) then { :!<> }
   Case SpecialWhat of
    scText:begin
     Inc(IOld);
     L:=IOld;
     While (L<=Len) and (DataStr[L]<>TextChar) do Inc(L);
     If L>Len then ErrorJump(0,Len,CurY,teTextEndExpected);
     Inc(L);
     CurSpecial:=True;

     With TopTerm^ do begin
      TermLen:=0;
      X:=IOld-1; Y:=CurY;
      TermType:=opStringConst;
      S:=Copy(DataStr,IOld,L-IOld-1);
      Ref:=NewString(S,True);
      CurStPos:=L; exit
     end
    end;

    scL:
     case DataStr[L+1] of
      GreatChar:begin
       t:=rtNE; Inc(L)
      end;
      AssignChar:begin
       t:=rtLE; Inc(L)
      end;
     end;

    scG:
     If DataStr[L+1]=AssignChar then begin
      t:=rtGE; Inc(L)
     end;

    scColon..scV:
     If DataStr[L+1]=AssignChar then begin
      If SpecialWhat=scColon then begin
       t:=rtE; Op:=opAssign
      end
      else begin
       t:=rtNE; Op:=opRel
      end;
      Inc(L)
     end;
   end; { case }
  Inc(L)
 end { If }

 else begin
  If IsNumber(DataStr[Iold]) then begin
   Op:=opConst;
   If (SpecialWhat<3) and ((DataStr[L-1]='E') or (DataStr[L-1]='e')) then begin
    Inc(L);
    While (L<=Len) and (IsSpecial(DataStr[L],SpecialWhat)=False) do Inc(L);
    CurSpecial:=True
   end
   else CurSpecial:=SpecialWhat=scBlank
  end
  else begin
   CurSpecial:=SpecialWhat=scBlank;
   Op:=opOther
  end
 end;

 With TopTerm^ do begin
  TermLen:=L-Iold;
  TermName:=Copy(DataStr,Iold,TermLen);
  X:=Iold; Y:=CurY;
  TermType:=Op;
  TermWhat:=t;

  Case Op of
   opConst: begin
     Val(TermName,Value,cod);
     If cod<>0 then begin
      If IsLetter(TermName[byte(cod)]) then TermWhat:=teMathExpected
      else
       If cod>Length(TermName) then TermWhat:=teBigFloat else TermWhat:=teSyntax;
      X:=X+cod-1;
      ErrorJump(0,X,Y,TermWhat)
     end
     else Ref:=AddConstant(Value);
    end;

    opOther: begin
      IsDiff:=False;
      K:=GetHashKey(TermName);
      If K>0 then
       Case TermName[K] of
        Diff1Char,Diff2Char:
         If K=TermLen then IsDiff:=True else ErrorJump(0,X+K-1,Y,teIncorrectChar);
        else ErrorJump(0,X+K-1,Y,teIncorrectChar);
       end;
      Ref:=AddTerm(TopTerm,TermName)
     end
  end { case }
 end; { with }
 CurStPos:=L
End;

Procedure TExprCompilator.MapError(Var Xe,Ye:word);
Begin End;

Procedure TExprCompilator.ErrorJump(CheckEnd:integer; Xe,Ye:word; Error:word);
Begin
 MapError(Xe,Ye);
 ErrorX:=Xe; ErrorY:=Ye;
 If CheckEnd<>0 then
  With TopTerm^ do
   If TermType=opEndData then begin
    ErrorX:=X; ErrorY:=Y; TransError:=teUnexpectedEnd;
    LongJump(JumpPoint)
   end;
 TransError:=Error;
 LongJump(JumpPoint)
End;

Procedure TExprCompilator.TranslateFunc(T:PTermTree; IsFunc,IsDirect:boolean);
Var K:PFuncFacts; P,Q,F:PFunction; B:boolean; I,J,N,l,lp:word; Op,Op1:OpsType;
    Old:integer; Last:PMultiParRec; AByValue:boolean;
 Procedure NewMP;
 var MP:PMultiParRec;
 begin
  MP:=NewMemTmp(SizeOf(TMultiParRec));
  MP^.Prev:=Last;
  Last:=MP;
  MP^.ByValue:=True;
 end;
Begin
 P:=PHashCell(ATerms[not CurTerm].Ref)^.WhatD;
 With P^ do begin
  N:=NPars;
  If not SimpleIfAllConst then ExNeed:=True;
  If IsDirect then Inc(NCalcs) { 맮 - }
  else begin
   Inc(NCalcs,N+NParVars+2);
   If not IsFunc then Dec(NCalcs) {   - - }
  end;
 end;
 { । - +  - ( 뫮 -) +
   맮 - + । - -  CalcStack }

 With TopTerm^ do
  If TopTerm^.TermType<>opLBra then
   If N=0 then exit { -  -  -  ᪮ }
   else ErrorJump(0,X,Y,teLBraExpected);

 If N=0 then begin { -  -,  -  ᪮ }
  GetTerm; { ய᪠ ( }
  With TopTerm^ do
   If TopTerm^.TermType<>opRBra then ErrorJump(0,X,Y,teRBraExpected)
   else begin
    GetTerm; { ய᪠ ) }
    exit
   end
 end;

 Inc(NBraL);
 K:=NewMemTmp(SizeOf(TExpression)*(N+1));
 K^[0].LocX:=0; K^[0].LocY:=0;
 T^.Head:=PTermTree(K);
 { ࠭塞, .. TransFunc-४ᨢ    - FutureStrError }
 Old:=FutureStrError;
 FutureStrError:=teCommaExpected;

 For I:=1 to N do begin
  B:=True; { False, ᫨ ᫥ ࠡ⪨ - TopTerm 㪠-  ࠧ⥫ }
  GetTerm;
  Op:=TopTerm^.TermType;
  Op1:=P^.Pars[I].TermType;
  Case Op1 of
   opPar:begin {  뫪 }
    Case Op of
     opPar..opNewVar:begin
      If Op=opPar then ParInExpr:=True
      else { । ६ ⠭- opUknown }
       PHashCell(TopTerm^.Ref)^.TermType:=opUknown;
      K^[I].FTree:=TopTerm^.Ref { 㪠-  Hash ६ }
     end;
     else
      With TopTerm^ do ErrorJump(1,X,Y,teVarNameExpected);
    end;
   end;

   opVar:begin {  - }
    J:=NCalcs;
    K^[I].FTree:=TranslateExpression(False,False);
    If NCalcs=J then Inc(NCalcs);
    B:=False
   end;

   opArrayVar..opAnyArrVar:
    If (Op=Op1) or ((Op1=opAnyArrVar) and (Op>=opArrayVar) and (Op<=opAnyArrVar)) then
     K^[I].FTree:=TopTerm^.Ref { Hash 䠪᪮ ᨢ }
    else
     With TopTerm^ do ErrorJump(1,X,Y,teArrayNameExpected+Op1-opArrayVar);

   opUserFunc,opUserProc:
    If ((Op1=opUserFunc) and ((Op=opUserFunc) or (Op=opParFunc))) or
       ((Op1=opUserProc) and ((Op=opUserProc) or (Op=opParProc)))
    then
     With TopTerm^ do begin
      Q:=PFunction(P^.Pars[I].Hash^.WhatD); { ଠ쭠 }
      F:=PFunction(PHashCell(Ref)^.WhatD);  { 䠪᪠ }
      B:=(Q^.NPars<>F^.NPars); { ࠢ ᫮  ⨯ - }
      If not B then
       For J:=1 to Q^.NPars do B:=B or (Q^.Pars[J].TermType<>F^.Pars[J].TermType);
      If B then ErrorJump(0,X,Y,teFuncMismatch);
      B:=True;
      K^[I].FTree:=Ref { Hash 䠪. - }
     end
    else begin
     If Op1=opUserFunc then I:=teFuncNameExpected else I:=teProcNameExpected;
     With TopTerm^ do ErrorJump(1,X,Y,I);
    end;

   opStringVar:begin
    { 塞 teCommaExpected  teRBraExpected }
    If I=N then FutureStrError:=teRBraExpected;
    K^[I].FTree:=TranslateStrExpression(False);
    B:=False
   end;

   opStringPar:
    Case Op of
     opStringVar..opStringPar: begin
      K^[I].FTree:=TopTerm^.Ref; {  }
      If Op<>opStringPar then { । ६ ⠭- opStringPar }
       PHashCell(TopTerm^.Ref)^.TermType:=opStringPar;
     end;
     else
      With TopTerm^ do ErrorJump(1,X,Y,teStringVarExpected)
    end;

   opUserVar1..opUserVar2:
    If Op1=Op then K^[I].FTree:=TopTerm^.Ref
    else begin
     ErrorData:=Op1-UserTypeVarDelta;
     With TopTerm^ do ErrorJump(1,X,Y,teUserVarExpected);
    end;

   opMultiVar:begin
    If Op<>opLBrack then With TopTerm^ do ErrorJump(1,X,Y,teLBrackExpected);
    GetTerm; { ய᪠ [ }
    Last:=nil;
    l:=0;  { 稪 - 䠪. - }
    lp:=0; { 稪 - 䠪. -,।  뫪 }
    While True do begin
     B:=TopTerm^.TermType=opOutSign;
     If B then GetTerm; { ய᪠ @ }
     Op:=TopTerm^.TermType;
     case Op of
      opStrArrVar,opStringConst..opStringPar,opStringFunc,opDirectStrFunc:begin
       Inc(l);
       NewMP;
       Last^.WhatExpr:=wmpStrMultiPar;
       If B then begin
        ExNeed:=True;
        Last^.ByValue:=False;
        Inc(lp);
        case Op of
         opStringPar: Last^.Expr:=TopTerm^.Ref; { Hash }
         opStringVar..opStringDouble: begin
          Last^.Expr:=TopTerm^.Ref; { Hash }
          { । ६ ⠭- opStringPar }
          PHashCell(TopTerm^.Ref)^.TermType:=opStringPar;
         end;
         else With TopTerm^ do ErrorJump(0,X,Y,teStringVarExpected)
        end
       end
       else Last^.Expr:=TranslateStrExpression(False);
      end;
      opArrayVar..opAnyArrVar:begin
       ExNeed:=True;
       Inc(l);
       NewMP;
       Last^.Expr:=TopTerm^.Ref; { Hash 䠪᪮ ᨢ }
       Last^.WhatExpr:=wmpArrayMultiPar;
       GetTerm; { ய⨬  ᨢ }
      end;
      opUserVar1..opUserVar2:begin
       Inc(l);
       NewMP;
       Last^.WhatExpr:=Op-UserTypeVarDelta;
       If B then begin
        Last^.ByValue:=False;
        Inc(lp);
        ExNeed:=True
       end;
       Last^.Expr:=TopTerm^.Ref { 㪠-  Hash ६ }
      end;
      opRBrack: break; {  㪠   - }
      else begin
       Inc(l);
       NewMP;
       Last^.WhatExpr:=wmpFloatMultiPar;
       Case Op of
        opPar..opNewVar:begin
         If B then begin {  뫪 }
          ExNeed:=True;
          If Op=opPar then ParInExpr:=True
          else { । ६ ⠭- opUknown }
           PHashCell(TopTerm^.Ref)^.TermType:=opUknown;
          Last^.ByValue:=False;
          Inc(lp);
          Last^.Expr:=TopTerm^.Ref { 㪠-  Hash ६ }
         end
        end;
        else
         If B then With TopTerm^ do ErrorJump(1,X,Y,teVarNameExpected)
       end;

       If not B then begin {  祭 }
        J:=NCalcs;
        Last^.Expr:=TranslateExpression(False,False);
        If NCalcs=J then Inc(NCalcs);
       end
      end;
     end;

     Case TopTerm^.TermType of
      opComma: GetTerm; { ய⨬ , }
      opRBrack: break;
      else With TopTerm^ do ErrorJump(1,X,Y,teRBrackExpected);
     end;
    end; { while }
    B:=True;
    K^[I].FTree:=pointer(Last);
    Inc(NCalcs,l (*+lp*));
    K^[0].LocX:=l; (*K^[0].LocY:=lp*)
   end;
  end; { case }

  If B then GetTerm; { 砥 ࠧ⥫  ᪮ }
  With TopTerm^ do
   Case TermType of
    opComma:
     If I=N then ErrorJump(0,X,Y,teRBraExpected);
    opRBra:
     If I<N then ErrorJump(0,X,Y,teCommaExpected)
     else begin
      Dec(NBraL);
      TransError:=teOK;
      { - NRaL,   NBra, ..   砥 AA(X,8 ~)~ 뤠 teBraUnneccessary }
      GetTerm; { ய᪠ ) }
     end
    else begin
     If I=N then J:=teRBraExpected else J:=teCommaExpected;
     ErrorJump(1,X,Y,J)
    end
   end;
 end; { for }
 FutureStrError:=Old;
End;

Function TExprCompilator.TranslateExpression(PlusSearch,Back:boolean):PTermTree;
{  ᫮ ࠦ }
Label 1;
Var B:boolean; P,K:PTermTree; Op:OpsType; I:integer;
Begin
 With TopTerm^ do begin
  Op:=TermType;
  GetTerm;
  Case Op of
   opLBra:begin
    Inc(NBraE);
    P:=TranslateExpression(False,False);
    If TopTerm^.TermType<>opRBra then With ATerms[not CurTerm] do
     ErrorJump(0,X+TermLen,Y,teRBraExpected);
    Dec(NBraE);
    GetTerm
   end;

   opPar..opUknown:begin
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=Op;
     WhatR:=Ref;
     If Op=opPar then ParInExpr:=True;
     ExNeed:=True
    end
   end;

   opConst..opVar:begin
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=Op; WhatR:=Ref;
    end;
   end;

   opFunc1,opPolinom:begin
    Inc(NCalcs);
    If TopTerm^.TermType<>opLBra then ErrorJump(0,X+TermLen,Y,teLBraExpected);
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=Op;
     If Op=opFunc1 then What:=TermWhat
     else WhatR:=Ref {    }
    end;
    GetTerm;
    Inc(NBraE);
    P^.Head:=TranslateExpression(False,False);
    If TopTerm^.TermType<>opRBra then
     With ATerms[not CurTerm] do ErrorJump(0,X+TermLen,Y,teRBraExpected);
    Dec(NBraE);
    If Op=opPolinom then ExNeed:=True;
    GetTerm
   end;

   opFunc2:begin
    If TermWhat=moMinus then begin
     Inc(NCalcs);
     P:=NewMemTmp(SizeOf(TTermTree));
     With P^ do begin
      What:=f1Neg;
      TermType:=opFunc1;
      Head:=TranslateExpression(False,True)
     end
    end
    else ErrorJump(0,X,Y,teEIE)
   end;

   opUserConst:begin
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=opConst;
     WhatR:=@PHashCell(Ref)^.Value
    end;
   end;

   opArrayVar:begin
    Inc(NCalcs);
    If TopTerm^.TermType<>opLBrack then ErrorJump(1,X+TermLen,Y,teLBrackExpected);
    Inc(NBrack);
    P:=NewMemTmp(SizeOf(TTermTree));

    With P^ do begin
     TermType:=opArrayVar;
     WhatR:=Ref; {   ᨢ }
     GetTerm; { ய᪠ [ }
     Head:=TranslateExpression(False,False);

     Case TopTerm^.TermType of
      opRBrack: Tail:=nil;
      opComma:begin
       GetTerm;
       Tail:=TranslateExpression(False,False)
      end
     end
    end;

    If TopTerm^.TermType<>opRBrack then
     With ATerms[not CurTerm] do ErrorJump(0,X+TermLen,Y,teRBrackExpected);
    Dec(NBrack);
    GetTerm;
    ExNeed:=True
   end;

   opUserFunc,opParFunc,opDirectFunc:begin
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=Op;
     WhatR:=Ref {   - }
    end;
    TranslateFunc(P,True,Op=opDirectFunc);
    If Op=opParFunc then ExNeed:=True;
   end;

   opFloatDef:begin
    With TopTerm^ do
     If TermType<>opLBra then ErrorJump(1,X,Y,teLBraExpected);
    GetTerm; { ய⨬ ( }
    P:=NewMemTmp(SizeOf(TTermTree));
    With TopTerm^ do
     case TermType of
      opUserVar1..opUserVar2:begin
       P^.TermType:=opUknown;
       P^.WhatR:=Ref;
       ExNeed:=True
      end;
      else ErrorJump(1,X,Y,teBadPrivOp);
     end;
    GetTerm; { 稬 ) }
    With TopTerm^ do
     If TermType<>opRBra then ErrorJump(1,X,Y,teRBraExpected);
    GetTerm; { ய⨬ ) }
   end;

   opYetDone:P:=LastTree;

   else begin
    Case Op of
     opStrArrVar,opStringConst..opStringPar,opStringFunc,opDirectStrFunc,
     opUserVar1..opUserVar2:
      I:=teFloatExpected;
     opNewVar: I:=teUknownVar;
     else I:=teEIE
    end;
    ErrorJump(1,X,Y,I);
   end;
  end; { case }
 end; { with }

1:
 If Back and (TopTerm^.TermWhat<>moPower) then begin
  TranslateExpression:=P; exit
 end;

 With TopTerm^ do begin
  Op:=TermType;
  Case Op of
   opRBra:begin
    If NBraE=0 then
     If NBraL=0 then ErrorJump(0,X,Y,teBraUnnecessary)
     else TransError:=teBraFromLogic
   end;

   opFunc2:begin
    Case TermWhat of
     moPlus..moMinus:B:=True
     else B:=False
    end;
    If B then
     If PlusSearch then begin
      TranslateExpression:=P; exit
     end;
    Inc(NCalcs);
    K:=NewMemTmp(SizeOf(TTermTree));
    With K^ do begin
     Head:=P;
     TermType:=opFunc2;
     What:=TermWhat
    end;
    GetTerm;
    K^.Tail:=TranslateExpression(B,not B);
    P:=K;
    goto 1
   end;

   opSemiColon..opComma: ;
   {opElse: ErrorJump(0,X,Y,FutureError);}
   opElse: ErrorJump(0,X,Y,teEIE);
   else ErrorJump(0,X,Y,teEndExpected)
  end { case }
 end; { with }
 TranslateExpression:=P
End;

Function TExprCompilator.TranslateStrExpression(Back:boolean):PTermTree;
{  ப ࠦ }
Var Op:OpsType; P,K:PTermTree;
Begin
 With TopTerm^ do begin
  Op:=TermType;
  P:=NewMemTmp(SizeOf(TTermTree));
  With P^ do begin
   TermType:=Op; WhatR:=Ref
  end;

  Case Op of
   opStringConst..opStringPar:begin
    Inc(NCalcs);
    If Op=opStringPar then ExNeed:=True;
    GetTerm
   end;

   opStringFunc,opDirectStrFunc:begin
    GetTerm; { 室  ( }
    TranslateFunc(P,True,Op=opDirectStrFunc);
   end;

   opStrArrVar:begin
    GetTerm; { 砥 [ }
    If TopTerm^.TermType<>opLBrack then With TopTerm^ do
     ErrorJump(1,X,Y,teLBrackExpected);
    GetTerm; { ய᪠ [ }
    Inc(NCalcs);

    P^.Head:=TranslateExpression(False,False);
    P^.Tail:=nil; { ⮫쪮   - # ப }
    With TopTerm^ do
     If TermType<>opRBrack then ErrorJump(1,X,Y,teRBrackExpected);
    ExNeed:=True;
    GetTerm; { ய᪠ ] }
   end;

   opNewVar: ErrorJump(0,X,Y,teUknownVar);
   else ErrorJump(1,X,Y,teStrExprExpected)
  end;
 end;

 While not Back do begin
  With TopTerm^ do
   Case TermType of
    opSemiColon..opComma,opRBra: Back:=True;

    opFunc2:
     If TermWhat=moPlus then begin
      K:=NewMemTmp(SizeOf(TTermTree));
      K^.TermType:=opStrConcat;
      K^.Head:=P;
      Inc(NCalcs);
      GetTerm; { ய᪠ + }
      K^.Tail:=TranslateStrExpression(True);
      P:=K
     end
     else ErrorJump(0,X,Y,teOpTypesMismatch);
    {else ErrorJump(1,X,Y,teEndExpected)}
    else ErrorJump(1,X,Y,FutureStrError)
   end;
 end;
 TranslateStrExpression:=P
End;

Procedure TExprCompilator.TranslateMath(Var P:TExpression; IsFunc:boolean);
Var Op:OpsType; T:PTermTree;
Begin
 With P do begin
  With TopTerm^ do begin
   LocX:=X; LocY:=Y
  end;
  NCalcs:=0; NBraE:=0; NBrack:=0;
  ExNeed:=False;
  ParInExpr:=False; {Need:=False;}

  If IsFunc then FTree:=TranslateExpression(False,False)
  else begin
   With TopTerm^ do begin
    Op:=TermType;
    T:=NewMemTmp(SizeOf(TTermTree));
    With T^ do begin
     TermType:=Op; WhatR:=Ref
    end;
   end;
   GetTerm; { 室  ( }
   TranslateFunc(T,False,Op=opDirectProc);
   FTree:=T
  end;

  NCalc:=NCalcs;
  If NCalc=0 then NCalc:=1;
  ContainPar:=ContainPar or ParInExpr;
 end
End;

Procedure TExprCompilator.TranslateString(Var P:TExpression);
Begin
 With P do begin
  With TopTerm^ do begin
   LocX:=X; LocY:=Y
  end;
  NCalcs:=0; NBraE:=0; NBrack:=0; ExNeed:=False;
  ParInExpr:=False;
  FTree:=TranslateStrExpression(False);
  NCalc:=NCalcs;
  ContainPar:=ContainPar or ParInExpr;
 end
End;

Function TExprCompilator.NewString(Var S:string; IsConst:boolean):PText;
Var P:PText; L:byte absolute S; I:byte;
Begin
 If IsConst then I:=L+1 else I:=TextTermSize;
 P:=NewMem(I);
 If IsConst then FastMove(S[0],P^,I) else P^:='';
 NewString:=P
End;

Function TExprCompilator.TranslateRelation:PBoolExpression;
{  ࠦ ⭮襭 }
Var P:PBoolExpression; N,I:word; Loc:PToken; B,IsError:boolean;
Begin
 P:=NewMemTmp(SizeOf(TBoolExpression));

 ErrorLevel:=0;
 N:=0;
 Loc:=TopTerm;
 Case TopTerm^.TermType of
  opStrArrVar,opStringConst..opStringPar,opStringFunc,opDirectStrFunc:
   I:=LastrtFloat+1;
  else I:=0
 end;
 IsError:=False; { 뫠 teBraFromLogic ? }
 FutureStrError:=teRelExpected;
 FutureError:=teRelExpected;

 Repeat
  If I=0 then TranslateMath(P^.Left,True) else TranslateString(P^.Left);
  If TransError=teBraFromLogic then begin
   B:=False;
   IsError:=True;
   { 塞 opRBra  opYetDone }
   ContainPar:=ContainPar or ParInExpr;
   {With P^.Left do Need:=Need or ExNeed;}
   Inc(N,NCalcs);
   Inc(ErrorLevel);
   LastTree:=P^.Left.FTree;
   Dec(NBraL);
   ATerms[CurTerm].TermType:=opYetDone;
   TransError:=0;
  end
  else B:=True;
 until B;

 If N>0 then begin
  P^.Left.NCalc:=N+NCalcs;
  With P^.Left do begin
   LocX:=Loc^.X; LocY:=Loc^.Y
  end
 end
 else
  If IsError then { e.g. '(3)/2>8' }
   { 뫮 teBraFromLogic,  NCalcs['3)']=0, => N=0  P^.Left.LocX=3,  ୮ }
   With P^.Left do begin
    LocX:=Loc^.X; LocY:=Loc^.Y
   end;

 With TopTerm^ do
  Case TermType of
   opRel,opAssign:begin
    P^.What:=TermWhat+I;
    GetTerm; { ய᪠ - ࠢ }
    If I=0 then TranslateMath(P^.Right,True) else TranslateString(P^.Right);
    TransError:=0
   end;
   else ErrorJump(1,X,Y,teRelExpected)
  end;
 TranslateRelation:=P
End;

Function TExprCompilator.TranslateLogic(LogSearch,Back:boolean):PLogicTree;
{  ᪮ ࠦ }
Var P,K:PLogicTree; OldLogCalcs:word;
Label 2;
Begin
 Case TopTerm^.TermType of
  opLBra:begin
   OldLogCalcs:=NLogCalcs;
   Inc(NBraL);
   GetTerm; { ய᪠ ( }
   P:=TranslateLogic(False,False);
   If ErrorLevel<>0 then begin
    { 墠⨫ ᪮ (, ⭮  .ࠦ- - 室  譥 ४ᨨ }
    Dec(ErrorLevel);
    Back:=True
   end
   else
    If NBral<>0 then
     { NBraL / ࠢ 0, ᫨ ,  ᪮ ⭮  .ࠦ- }
     If TopTerm^.TermType<>opRBra then
      With ATerms[not CurTerm] do ErrorJump(0,X+TermLen,Y,teRBraExpected)
     else begin
      Dec(NBraL);
      GetTerm { ய᪠ ) }
     end
  end;

  opLogic:begin
   If TopTerm^.TermWhat=ltNOT then begin
    P:=NewMemTmp(SizeOf(TLogicTree));
    GetTerm; { ய᪠ NOT }
    Inc(NLogCalcs);
    With P^ do begin
     What:=etLogic;
     LogicOp:=ltNot;
     Left:=TranslateLogic(False,True)
    end
   end
   else
    With TopTerm^ do ErrorJump(0,X,Y,teEIE)
  end;

  opCompFunc:begin { IsTrue, IsFalse }
   P:=NewMemTmp(SizeOf(TLogicTree));
   Inc(NLogCalcs);
   with P^ do begin
    LogicOp:=TopTerm^.TermWhat;
    What:=etCompFunc;
    GetTerm; { 砥 ( }
    With TopTerm^ do
     If TermType<>opLBra then ErrorJump(1,X,Y,teLBraExpected);
    GetTerm; { ய᪠ ( }
    Inc(NBraL);
    Left:=NewMemTmp(SizeOf(TExpression));
    TranslateMath(PExpression(Left)^,True);
    TransError:=teOK;
    With TopTerm^ do
     If TermType<>opRBra then ErrorJump(0,X,Y,teRBraExpected);
    GetTerm; { ய᪠ ) }
    Dec(NBraL);
   end
  end;

  else begin
   P:=NewMemTmp(SizeOf(TLogicTree));
   With P^ do begin
    What:=etBool;
    Inc(NLogCalcs);
    Left:=TranslateRelation;
    If ErrorLevel<>0 then begin
     Dec(ErrorLevel);
     Back:=True
    end;
   end
  end
 end; { case }

 If Back then begin
  TranslateLogic:=P; exit
 end;

2:
 With TopTerm^ do
  Case TermType of
   opRBra:
    If NBraL=0 then ErrorJump(0,X,Y,teBraUnnecessary);

   opLogic:
    If TermWhat=ltNot then ErrorJump(0,X,Y,teEIE)
    else
     If not LogSearch then begin
      K:=NewMemTmp(SizeOf(TLogicTree));
      Inc(NLogCalcs);
      With K^ do begin
       What:=etLogic;
       LogicOp:=TermWhat;
       Left:=P;
       GetTerm;
       Right:=TranslateLogic(True,False)
      end;
      P:=K;
      goto 2
     end;

   opDo..opThen,opSemiColon..opEndData: ;
   opIf..opEnd: TermType:=opBadLog;
   else ErrorJump(0,X,Y,teEIE)
  end;
 TranslateLogic:=P
End;

Function TExprCompilator.GetParNums:word;
Begin
 GetParNums:=ParList^.Count
End;

Function TExprCompilator.GetParDesc(Num:integer; Var IdDef:TIdDef):boolean;
Var P:POutVar;
Begin
 If Num>ParList^.Count then GetParDesc:=False
 else begin
  P:=ParList^.At(Num-1);
  With P^ do begin
   IdDef.Name:=@HVar^.Name;
   IdDef.Value:=@HVar^.Value;
   IdDef.F1:=F1; IdDef.F2:=F2
  end;
  GetParDesc:=True
 end
End;

End.
