{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit StrD2x2; { ப - }
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses Hash2x2,ExprComp;

Procedure RegisterStrFuncs(Compilator:PExprCompilator);

Implementation
Uses MyString,Def2x2,TPDate;

function SConcat(s1,s2:string):string;
begin
 SConcat:=s1+s2
end;

function SCenter(Str:string; Len:byte):string;
begin
 SCenter:=CenterStr(Str,Len,' ')
end;

function SLength(Str:string):byte;
begin
 SLength:=Length(Str)
end;

function SStr(E:extended; L1,L2:byte):string;
var s:string;
Begin
 Str(E:L1:L2,s);
 SStr:=s
End;

function SStrExp(E:extended; L:byte):string;
var s:string;
Begin
 Str(E:L,s);
 SStrExp:=s
End;

function SChar(c:byte):string;
Begin
 SChar:=char(c)
End;

function SLongStr(E:longint; Width:byte):string;
var s:string;
Begin
 If Width=0 then Str(E,s) else Str(E:Width,s);
 SLongStr:=s
End;

function GetChar(s:string; cpos:byte):byte;
begin
 If cpos>Length(s) then GetChar:=0 else GetChar:=byte(s[cpos]);
end;

procedure SetChar(var s:string; cpos,ch:byte);
begin
 If cpos<=Length(s) then s[cpos]:=char(ch)
end;

procedure SInsert(Var Target:string; Obj:string; Pos:integer);
begin
 MyString.SInsert(Target,Obj,TextTermSize,Pos)
end;

procedure SSwap(Var Str:string; Find,Repl:string);
var Enough:boolean;
begin
 SwapSubstring(Str,Find,Repl,Enough,TextTermSize);
end;

function StrToDate(s:string):word;
Begin
 FlipChar(S,'.','/');
 StrToDate:=DateStringToDate('dd/mm/yy',S);
End;

function DateStr(Dt:Date):string;
Var D,M,Y:integer;
Begin
 If Dt=BadDate then DateStr:=''
 else begin
  DateToDMY(Dt,D,M,Y);
  DateStr:=ToDateStr(D,M,Y-1900);
 end;
End;

function TimeStr(t:word):string;
Begin
 TimeStr:=ToTimeStr(t shr 8,t and $00FF)
End;

function Trim(s:string):string;
begin
 FastTrim(s);
 Trim:=s
end;

function TrimEnd(s:string):string;
begin
 FastTrimEnd(s);
 TrimEnd:=s
end;

function TrimHead(s:string):string;
begin
 FastTrimHead(s);
 TrimHead:=s
end;

procedure SVal(s:string; var R:extended; var code:integer);
begin
 Val(s,r,code)
end;

procedure StrFuncDefs;assembler;
asm
 dw wcFunc                  { func/proc }
 db 5,'LTRIM'               {  ,  }
 dw 1                       { - - }
 db dctString,pptString,1   { ⨯ 22, ⨯ Pascal, 0/1 - 뫪/ 祭 }
 dw rtString,prtString      { 頥 ⨯ 22, 頥 ⨯ Pascal }
 dw SEG TrimHead, OFFSET TrimHead {  -/楤 }
 db 1

 dw wcFunc                  { func/proc }
 db 5,'RTRIM'               {  ,  }
 dw 1                       { - - }
 db dctString,pptString,1   { ⨯ 22, ⨯ Pascal, 0/1 - 뫪/ 祭 }
 dw rtString,prtString      { 頥 ⨯ 22, 頥 ⨯ Pascal }
 dw SEG TrimEnd, OFFSET TrimEnd
 db 1

 dw wcFunc                  { func/proc }
 db 4,'TRIM'                {  ,  }
 dw 1                       { - - }
 db dctString,pptString,1   { ⨯ 22, ⨯ Pascal, 0/1 - 뫪/ 祭 }
 dw rtString,prtString      { 頥 ⨯ 22, 頥 ⨯ Pascal }
 dw SEG Trim, OFFSET Trim
 db 1

 dw wcFunc
 db 8,'UPPERSTR'
 dw 1
 db dctString,pptString,1
 dw rtString,prtString
 dw SEG UpperCase, OFFSET UpperCase
 db 1

 dw wcFunc
 db 6,'CONCAT'
 dw 2
 db dctString,pptString,1 { 1- ࠬ }
 db dctString,pptString,1 { 2- ࠬ }
 dw rtString,prtString
 dw SEG SConcat, OFFSET SConcat
 db 1

 dw wcFunc
 db 4,'LPAD'
 dw 2
 db dctString,pptString,1
 db dctFloat,pptByte,1
 dw rtString,prtString
 dw SEG LPad, OFFSET LPad
 db 1

 dw wcFunc
 db 4,'RPAD'
 dw 2
 db dctString,pptString,1
 db dctFloat,pptByte,1
 dw rtString,prtString
 dw SEG RPad, OFFSET RPad
 db 1

 dw wcFunc
 db 6,'CENTER'
 dw 2
 db dctString,pptString,1
 db dctFloat,pptByte,1
 dw rtString,prtString
 dw SEG SCenter, OFFSET SCenter
 db 1

 dw wcProc
 db 6,'INSERT'
 dw 3
 db dctString,pptString,0
 db dctString,pptString,1
 db dctFloat,pptInt,1
 dw rtDontCare,prtDontCare
 dw SEG SInsert, OFFSET SInsert
 db 0

 dw wcProc
 db 6,'DELETE'
 dw 3
 db dctString,pptString,0
 db dctFloat,pptInt,1
 db dctFloat,pptInt,1
 dw rtDontCare,prtDontCare
 dw SEG SDelete, OFFSET SDelete
 db 0

 dw wcFunc
 db 6,'SUBSTR'
 dw 3
 db dctString,pptString,1
 db dctFloat,pptInt,1
 db dctFloat,pptInt,1
 dw rtString,prtString
 dw SEG SCopy, OFFSET SCopy
 db 1

 dw wcProc
 db 10,'SWAPSUBSTR'
 dw 3
 db dctString,pptString,0
 db dctString,pptString,1
 db dctString,pptString,1
 dw rtDontCare,prtDontCare
 dw SEG SSwap, OFFSET SSwap
 db 0

 dw wcFunc
 db 6,'LENGTH'
 dw 1
 db dctString,pptString,1
 dw rtFloat,prtByte
 dw SEG SLength, OFFSET SLength
 db 1

 dw wcFunc
 db 3,'POS'
 dw 2
 db dctString,pptString,1
 db dctString,pptString,1
 dw rtFloat,prtByte
 dw SEG SPos, OFFSET SPos
 db 1

 dw wcFunc
 db 7,'WILDPOS'
 dw 3
 db dctString,pptString,1
 db dctString,pptString,1
 db dctFloat,pptInt,1
 dw rtFloat,prtInt
 dw SEG WildPosAfter, OFFSET WildPosAfter
 db 1

 dw wcFunc
 db 3,'STR'
 dw 3
 db dctFloat,pptExtended,1
 db dctFloat,pptByte,1
 db dctFloat,pptByte,1
 dw rtString,prtString
 dw SEG SStr, OFFSET SStr
 db 1

 dw wcFunc
 db 6,'STREXP'
 dw 2
 db dctFloat,pptExtended,1
 db dctFloat,pptByte,1
 dw rtString,prtString
 dw SEG SStrExp, OFFSET SStrExp
 db 1

 dw wcFunc
 db 7,'LONGSTR'
 dw 2
 db dctFloat,pptLong,1
 db dctFloat,pptByte,1
 dw rtString,prtString
 dw SEG SLongStr, OFFSET SLongStr
 db 1

 dw wcFunc
 db 9,'STRTODATE'
 dw 1
 db dctString,pptString,1
 dw rtFloat,prtWord
 dw SEG StrToDate, OFFSET StrToDate
 db 1

 dw wcFunc
 db 7,'STRDATE'
 dw 1
 db dctFloat,pptWord,1
 dw rtString,prtString
 dw SEG DateStr, OFFSET DateStr
 db 1

 dw wcFunc
 db 7,'STRTIME'
 dw 1
 db dctFloat,pptWord,1
 dw rtString,prtString
 dw SEG TimeStr, OFFSET TimeStr
 db 1

 dw wcFunc
 db 6,'HEXSTR'
 dw 1
 db dctFloat,pptLong,1
 dw rtString,prtString
 dw SEG HexLong, OFFSET HexLong
 db 1

 dw wcFunc
 db 6,'BINSTR'
 dw 1
 db dctFloat,pptLong,1
 dw rtString,prtString
 dw SEG BinLong, OFFSET BinLong
 db 1

 dw wcFunc
 db 4,'CHAR'
 dw 1
 db dctFloat,pptByte,1
 dw rtString,prtString
 dw SEG SChar, OFFSET SChar
 db 1

 dw wcFunc
 db 7,'GETCHAR'
 dw 2
 db dctString,pptString,1
 db dctFloat,pptByte,1
 dw rtFloat,prtByte
 dw SEG GetChar, OFFSET GetChar
 db 1

 dw wcProc
 db 7,'SETCHAR'
 dw 3
 db dctString,pptString,0
 db dctFloat,pptByte,1
 db dctFloat,pptByte,1
 dw rtDontCare,prtDontCare
 dw SEG SetChar, OFFSET SetChar
 db 0

 dw wcFunc
 db 8,'FILLCHAR'
 dw 2
 db dctFloat,pptByte,1
 db dctFloat,pptByte,1
 dw rtString,prtString
 dw SEG FillStr, OFFSET FillStr
 db 1

 dw wcProc
 db 3,'VAL'
 dw 3
 db dctString,pptString,1
 db dctFloat,pptExtended,0
 db dctFloat,pptInt,0
 dw rtDontCare,prtDontCare
 dw SEG SVal, OFFSET SVal
 db 0
end;

Procedure RegisterStrFuncs(Compilator:PExprCompilator);
begin
 AddNewFunc(28,@StrFuncDefs,Compilator);
end;

End.