{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit Calcer;
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses Def2x2,Matrdef,Diffy,Objects,X1,MyString;

Type

 Float=extended;
 PFloat=^Float;
 PPointer=^pointer;

 PTermTree=^TTermTree;
 TTermTree=record       { - ॢ -    }
  Tail,Head:PTermTree;  { ࠢ,  ॢ }
  TermType:OpsType;     { ⨯ ଠ            }
  case integer of
   0:(What:byte);       {  ଠ (-)     }
   1:(WhatR:pointer);   { 㪠⥫   ଠ }
 end;

 PExpression=^TExpression;
 TExpression=record   { .ࠦ }
  FTree:PTermTree;    { ॢ ࠦ }
  LocX,LocY:word;     {  1- ଠ }
  NCalc:word;         { ᫮ 権 }
  (*Need:boolean;     { True, ᫨ ᮤন Par,DoubleVar,Polinom,Array,UserFunc}*)
 end;

 TCalcCell=record    { - - - }
  MaySimple:boolean; { -   }
  Nop:byte;          {  ࠢ  ࠭ ᫮ }
  CellType:OpsType;  { opPar,opFunc,opConst; opConst--  㦭 }
  Ref:pointer;       { 㪠-  - }
  T1,T2:pointer;     { 㪠-   }
  Aux:pointer;
  case integer of    { १-  }
   0:(Result:Float);
   1:(ResultB:boolean);
   2:(ResultP:PText);
 end;
 ACalcStack=array[1..100] of TCalcCell;
 PCalcStack=^ACalcStack;

 PHashCell=^THashCell;
 THashCell=record     {  -⠡ }
  Name:TermString;    {  ଠ           }
  TermType:OpsType;   { ⨯ ଠ           }
  What:byte;          {  ଠ           }
  InUse:byte;         { 䫠   - }
  Next:PHashCell;
  HVal:PHashCell;
  WhatD:pointer;      { PFunction/PStructDef }
  case integer of
   0: (Value:Float);  { 祭 ६-, - }
   1: (ValueP:PText); { 祭 ⥪. ६-, - }
  end;

 TFuncPars=record   { ଠ - - }
  TermType:OpsType; { ⨯ - }
  Hash:PHashCell;   {  - }
  UTFlag:word;
 end;

 { ᨢ 䠪. - - }
 AFuncFacts=array[0..MaxFuncPars] of TExpression;
 PFuncFacts=^AFuncFacts;

 PMultiParRec=^TMultiParRec;
 TMultiParRec=record { ⥫ ࠦ ⨯ࠬ }
  WhatExpr:TMultiExprType; { 䠪. ⨯ ⨯- }
  Expr:pointer;            { ॢ ࠦ }
  ByValue:boolean;         { True ᫨ ।  祭 }
  Prev:PMultiParRec        {  ࣠樨 ᯨ᪠ }
 end;

 PFunction=^TFunction;
 TFunction=record	{ ᠭ - }
  NPars:byte;		{ ᫮ 㬥⮢ }
  NParVars:byte;	{ ᫮ -, ।  뫪 }
  FuncName:PHashCell;	{   - }
  SimpleIfAllConst:boolean;
  Pars:array[1..MaxFuncPars] of TFuncPars; { ଠ - }
  FuncCalc:pointer;	{ - - (TCalcer)/PDirectCall }
  EnableAssign:word;
 end;

 PCellList=^TCellList;
 TCellList=record       { ᠭ - ᨢ }
  F:TExpression;        { ࠦ 祭     }
  Next:PCellList
 end;

 PStructDef=^TStructDef;
 TStructDef=record     { ᠭ ᨢ,  }
  NameHash:PHashCell;  {                    }
  Cells:word;          { ᪮쪮  ⮢   }
  Extern:boolean;      { -           }
  SizeVal:TExpression; { - ࠧ               }
  Size2Val:TExpression;{ - 2-- ࠧ         }
  CellList:PCellList;  { - -                 }
  MType:MatrixType;    { ⨯ -                   }
  Data:pointer         { PMatrix/PPolinom           }
 end;

 PFormula=^TFormula;
 TFormula=record   { 㫠    }
  E:TExpression;   { ࠦ  }
  Loc:PHashCell    { Hash   }
 end;

 PUserTypeFormula=^TUserTypeFormula;
 TUserTypeFormula=record
  LocL:PHashCell;  { Hash   }
  LocR:PHashCell   { Hash ࠢ  }
 end;

 PPropFormula=^TPropFormula;
 TPropFormula=record
  LValue:TExpression; { ࠦ  }
  RValue:TExpression; { ࠦ  }
  Func:PFunction;
  Loc:PHashCell       { Hash   }
 end;

 PArrayCell=^TArrayCell;
 TArrayCell=record        { 㫠- ᨢ    }
  Loc:PHashCell;          { Hash                  }
  Index,Index2,FTree:TExpression {    祭 }
 end;

 PLogicTree=^TLogicTree;
 TLogicTree=record      { logic-ࠦ           }
  LogicOp:byte;         { ⨯ logic-樨        }
  What:byte;            { ⨯ ࠦ: logic,bool }
  Left,Right:pointer    { ,ࠢ ࠦ    }
 end;

 PBoolExpression=^TBoolExpression;
 TBoolExpression=record  { bool-ࠦ }
  What:byte;             { ⨯ 樨   }
  Left,Right:TExpression { ,ࠢ .ࠦ }
 end;

 PBlockList=^TBlockList;
 TBlockList=record         {  ᫥ }
  What:ExprType;           { ⨯        }
  Next:PBlockList;
  case integer of
   0:(NBlocks:word;                 { ᫮  }
      NDefBlocks,NStructDefs:byte); { ᫮ ᠭ }
   1:(Expr:pointer;)       {  }
 end;

 PWhileCycle=^TWhileCycle;
 TWhileCycle=record      {  While                    }
  LogCalcs:word;         { ᫮ . 権  ᫮ }
  Logic:PLogicTree;      { ॢ - ᫮          }
  BList:PBlockList       {  -  while       }
 end;

 PIfCycle=^TIfCycle;
 TIfCycle=record        {  If-else                  }
  LogCalcs:word;        { ᫮ . 権  ᫮ }
  Logic:PLogicTree;     { ॢ - ᫮          }
  BListIf,BListElse:PBlockList {  -  if  else }
 end;

 PPrintRec=^TPrintRec;
 TPrintRec=record	{ - ᯨ᪠ 뢮 - Print }
  F:TExpression;	{ - - }
  Expo:boolean;		{ True, ᫨ exp ଠ }
  F1,F2:byte		{  ଠ :F1:F2 }
 end;

 TDirectCallPar=record  { ⥫ - אַ 맮 }
  ParType:T2x2Type;       { ⨯ 22 }
  PascalType:TPasParType; { ⨯ Pascal }
  ByValue:boolean         { True ᫨ ।  祭 }
 end;
 { ᨢ ⥫ - אַ 맮 }
 TDirectCallPars=array[1..MaxFuncPars] of TDirectCallPar;

 TDirectStack=word;

 TCallPrepare=record { ⥫ ନ஢⥫ ⥪ }
  From:pointer; {  䠪. - }
  ToOfs:word;   { ᬥ饭  DirectStack }
  Aux:pointer;  { 㪠⥫  祭 楫, ।  뫪 }
  What:word     { ⨯ }
 end;
 { ᨢ ନ஢⥫ ⥪ }
 ACallPrepares=array[0..1] of TCallPrepare;
 PCallPrepares=^ACallPrepares;

 ArOfWord=array[0..1] of word;
 PArOfWord=^ArOfWord;

 PDirectCall=^TDirectCall;    { ⥫ ணࠬ אַ 맮 }
 TDirectCall=record
  ParsNum:integer;            { - - }
  WhatReturn:TReturnType;     { ⨯ 22 頥 祭 }
  PasReturn:TPasReturnType;   { ⨯ Pascal 頥 祭 }
  FuncAdr:pointer;            {  - }
  CallStackSize:word;         { ࠧ ⥪ }
  PrepareSize:word;           { ࠧ ନ஢⥫ ⥪  AfterPrepare }
  AfterPrepare:word;          { ࠧ ନ஢⥫  祭  뫪 }
  TemplatePrep:PCallPrepares; { ନ஢⥫ ⥪ }
  TmpAr:PArOfWord;            {  ࠭ 楫, ।  뫪 }
  CallStack:TDirectStack      { ⥪ 맮 }
 end;

 PCalcer=^TCalcer;
 TCalcer=object(TObject)  { ꥪ-᫨⥫ }
  procedure Evaluate;virtual;
  function Calculate:PFloat;virtual;
 end;

 { - . ࠦ }
 PExpressionCalcer=^TExpressionCalcer;
 TExpressionCalcer=object(TCalcer)
  Calcs:word;
  CalcStack:PCalcStack;
  ENeed:boolean;
  procedure BuildCalcStack(Tree:PTermTree; Var Need:boolean);
  constructor Init(Const F:TExpression);
  destructor Done;virtual;
  function Calculate:PFloat;virtual;
  procedure Evaluate;virtual;
  procedure Simplify;
 end;

 { - ப ࠦ }
 PStrExpressionCalcer=^TStrExpressionCalcer;
 TStrExpressionCalcer=object(TExpressionCalcer)
  function Calculate:PFloat;virtual;
 end;

 { - .  ᢠ }
 PFormulaCalcer=^TFormulaCalcer;
 TFormulaCalcer=object(TExpressionCalcer)
  ResAd:PFloat;
  LHash:PHashCell;
  constructor Init(F:PFormula);
  procedure Evaluate;virtual;
  function Simplify:boolean;
 end;

 { -  ᢠ 祭 - }
 PAssignFuncCalcer=^TAssignFuncCalcer;
 TAssignFuncCalcer=object(TFormulaCalcer)
  procedure Evaluate;virtual;
 end;

 { -  ᢠ --property }
 PFuncPropCalcer=^TFuncPropCalcer;
 TFuncPropCalcer=object(TExpressionCalcer)
  LHash:PHashCell;
  FR:PExpressionCalcer;
  constructor Init(F:PPropFormula; FloatFunc:boolean);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 PProcCalcer=^TProcCalcer;
 TProcCalcer=TExpressionCalcer;

 { - ப  ᢠ }
 PStrFormulaCalcer=^TStrFormulaCalcer;
 TStrFormulaCalcer=object(TExpressionCalcer)
  StrAd:PText;
  LHash:PHashCell;
  constructor Init(F:PFormula);
  procedure Evaluate;virtual;
  function Simplify:boolean;
 end;

 { -  ᢠ 祭 - }
 PAssignStrFuncCalcer=^TAssignStrFuncCalcer;
 TAssignStrFuncCalcer=object(TStrFormulaCalcer)
  procedure Evaluate;virtual;
 end;

 { -  ਢ ६ ⨯ - }
 PUTFormulaCalcer=^TUTFormulaCalcer;
 TUTFormulaCalcer=object(TCalcer)
  Hashes:TUserTypeFormula;
  constructor Init(F:PUserTypeFormula);
  procedure Evaluate;virtual;
 end;

 { -  ᢠ - ୮ - }
 PArrayCalcer=^TArrayCalcer;
 TArrayCalcer=object(TCalcer)
  MC:pointer;
  IndexC,ValC:PExpressionCalcer;
  constructor Init(F:PArrayCell);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -  ᢠ - ୮ ᨬ쭮 - }
 PStrArrayCalcer=^TStrArrayCalcer;
 TStrArrayCalcer=object(TArrayCalcer)
  constructor Init(F:PArrayCell);
 end;

 { -  ᢠ - 㬥୮ - }
 PMatrixCalcer=^TMatrixCalcer;
 TMatrixCalcer=object(TArrayCalcer)
  Index2C:PExpressionCalcer;
  constructor Init(F:PArrayCell);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { - ᪮ ࠦ }
 PLogicCalcer=^TLogicCalcer;
 TLogicCalcer=object(TCalcer)
  Calcs:word;
  CalcStack:PCalcStack;
  procedure BuildCalcStack(Tree:PLogicTree);
  constructor Init(ACalcs:word; Tree:PLogicTree);
  procedure Evaluate;virtual;
  function CalculateB:boolean;
  destructor Done;virtual;
 end;

 { -  If }
 PIfCalcer=^TIfCalcer;
 TIfCalcer=object(TCalcer)
  Condition:PLogicCalcer;
  BodyIf,BodyElse:PCalcer;
  constructor Init(P:PIfCycle);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -  While }
 PWhileCalcer=^TWhileCalcer;
 TWhileCalcer=object(TCalcer)
  Condition:PLogicCalcer;
  Body:PCalcer;
  constructor Init(P:PWhileCycle);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -  Break,Continue,Exit }
 PBCECalcer=^TBCECalcer;
 TBCECalcer=object(TCalcer)
  What:TRunBreak;
  constructor Init(AWhat:TRunBreak);
  procedure Evaluate;virtual;
 end;

 CalcerAr=array[1..2] of PCalcer;
 PCalcerAr=^CalcerAr;

 { -  ஢ }
 PBlockCalcer=^TBlockCalcer;
 TBlockCalcer=object(TCalcer)
  Operators:PCalcerAr;
  Calcs:word;
  Count:word;
  Global:boolean;
  First,Last:word;
  constructor Init(B:PBlockList; AGlobal:boolean);
  function CompileArrayDef(PS:PStructDef):boolean;
  function CompileFuncDef(PBL:PBlockList):boolean;
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { - - - }
 PUserFuncCalcer=^TUserFuncCalcer;
 TUserFuncCalcer=object(TBlockCalcer)
  procedure Evaluate;virtual;
 end;

 { ।  - }
 PMatrixAlloc=^TMatrixAlloc;
 TMatrixAlloc=object(TCalcer)
  Lines,Cols:word;     { ࠧ ᨢ }
  MType:MatrixType;    { ⨯ ᨢ }
  PData:pointer;       { 㪠-  TStructDef.Data }
  constructor Init(ALines,ACols:word; P:PStructDef);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { 㭨⮦  - }
 PMatrixDeAlloc=^TMatrixDeAlloc;
 TMatrixDeAlloc=object(TCalcer)
  PData:pointer; { 㪠-  TStructDef.Data }
  constructor Init(P:PStructDef);
  procedure Evaluate;virtual;
 end;

 { -  Print }
 PPrintCalcer=^TPrintCalcer;
 TPrintCalcer=object(TCalcer)
  Operators:PCalcerAr;
  Count:word;
  constructor Init(B:PBlockList);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -, 뢠     Print }
 PFlushLine=^TFlushLine;
 TFlushLine=object(TCalcer)
  Compiler:PCalcer;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 { -, 뢠 - Print  뢮 . ࠦ }
 PExpressionPrint=^TExpressionPrint;
 TExpressionPrint=object(TFlushLine)
  PE:PExpressionCalcer;
  TeF1,TeF2:byte;
  TeExp:boolean;
  constructor Init(F:PPrintRec);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { -, 뢠 - Print  뢮 ப ࠦ }
 PStrFormulaPrint=^TStrFormulaPrint;
 TStrFormulaPrint=object(TFlushLine)
  PS:PExpressionCalcer;
  constructor Init(F:PPrintRec);
  procedure Evaluate;virtual;
  destructor Done;virtual;
 end;

 { ࠪ  }
 PACompilator=^TACompilator;
 TACompilator=object(TCalcer)
  procedure Print(Var S:string); virtual;
  procedure FlushPrintLine; virtual;
  procedure ReadyPrint; virtual;
  function GetFuncAdres(What:word):pointer;virtual;
  function NewMem(Size:word):pointer;
  function NewMemTmp(Size:word):pointer;
  procedure DisposeMem(Index:word);
  procedure DisposeMemTmp(Index:word);
  constructor Init;
  destructor Done;virtual;
 private
  FreeSize:word;
  FreeIndex:word;
  FreeSizeTmp:word;
  FreeIndexTmp:word;
  Pointers:PointersList;      { ᯨ᮪ 㪠⥫ }
  PointersTmp:PointersList;   { ᯨ᮪ 㪠⥫ }
 end;

 { 訡  ࠡ - xxxCalcer }
 CompileError=record
  Error:word;
  cX,cY:word
 end;

Procedure ValidName(Var Name:string; Var Error:integer; Var ErrorPos:word);

Var
 CompError:CompileError;
 DefColl:PCollection; {  ꥪ⮢--  - - }
 InWhile:word;   { >0 ᫨  - 横 While }
 CurCompilator:PACompilator;

Implementation
Uses UserFunc;

{$I FUNCS.PAS}

Const

 { ⥪. ᫮ . - }
 CurLastFunc:word=moLMod;
 { ᫮ ⠭. . - }
 LastFuncAdres=moLMod;

 {  ⠭. - }

 FuncAdres:array[f1Neg..LastFuncAdres] of pointer=(
  @fNeg, @fSin, @fCos, @fTg, @fAsin, @fAcos, @fArctg,@fAbs, @fSqr, @fSqrt,
  @fRad, @fGrad, @fLn, @fLog, @fExp, @fSign,@fFrac, @fRound, @fTrunc, nil,
  @fError, @fPlus, @fMinus,@fMult, @fDiv, @fPower, @fLDiv, @fLMod);

 BoolFuncAdres:array[rtG..rtsNE] of pointer=(
  @fBG, @fBGE, @fBL, @fBLE, @fBE, @fBNE, @fIsZero, @fIsOne,
  @fsBG, @fsBGE, @fsBL, @fsBLE, @fsBE, @fsBNE );

 LogicFuncAdres:array[ltAND..ltXOR] of pointer=(@fLAnd, @fLOr, @fLNot, @fLXOR);

 BreakBit=1;
 ContinueBit=2;
 ExitBit=4;
 CalcBreakState:word=0;

Type
 TCalcFunc=procedure(Var P:TCalcCell);

Function GetFunc(What:byte):pointer;
Begin
 If What>FuncIndex2x2 then GetFunc:=CurCompilator^.GetFuncAdres(What)
 else GetFunc:=FuncAdres[What]
End;

Function GetBoolFunc(What:byte):pointer;
Begin
 GetBoolFunc:=BoolFuncAdres[What]
End;

Function GetLogicFunc(What:byte):pointer;
Begin
 GetLogicFunc:=LogicFuncAdres[What]
End;

Function CalcPolinomAddres:pointer;
Begin
 CalcPolinomAddres:=nil;
End;

Procedure TCalcer.Evaluate;
Begin End;

Function TCalcer.Calculate:PFloat;
Begin End;

Constructor TExpressionCalcer.Init(Const F:TExpression);
Begin
 GetMem(CalcStack, F.NCalc*SizeOf(TCalcCell));
 Calcs:=0;
 BuildCalcStack(F.FTree,ENeed);
 Simplify
End;

Destructor TExpressionCalcer.Done;
Begin
 FreeMem(CalcStack, Calcs*SizeOf(TCalcCell));
End;

Function TExpressionCalcer.Calculate:PFloat;
Begin
 Evaluate;
 Calculate:=@CalcStack^[1].Result
End;

Function TStrExpressionCalcer.Calculate:PFloat;
Begin
 Evaluate;
 Calculate:=PFloat(CalcStack^[1].ResultP)
End;

Procedure TExpressionCalcer.BuildCalcStack(Tree:PTermTree; Var Need:boolean);
Var Op,Op1:OpsType; K:PTermTree; B:boolean; P:PFunction; N,J,M,L,r:word;
    FF:PFuncFacts; Q:PMultiParRec;

 Procedure Leaf(Var T:pointer);
 Var Op:OpsType;
 Begin
  Op:=K^.TermType;
  Case Op of
   opConst:begin
    T:=K^.WhatR;
    Need:=False
   end;
   opPar,opUknown:begin
    T:=@PHashCell(K^.WhatR)^.Value;
    Need:=True
   end;
   opDoubleVar..opVar:
    with PHashCell(K^.WhatR)^ do begin
     T:=@Value;
     If (InWhile<>0) and not (TermType in [opDoubleVar,opVar]) then Need:=True
     else Need:=False
    end;
   else begin
    T:=@CalcStack^[Calcs+1].Result;
    BuildCalcStack(K,Need);
   end
  end
 End;

Begin
 Inc(Calcs);
 With CalcStack^[Calcs] do begin
  Op:=Tree^.TermType;

  Case Op of
   opConst:begin
    CellType:=opConst;
    Result:=PFloat(Tree^.WhatR)^;
    Need:=False
   end;

   opFunc1:begin
    CellType:=opFunc;
    K:=Tree^.Head;
    Leaf(T1);
    Ref:=GetFunc(Tree^.What)
   end;

   opFunc2:begin
    CellType:=opFunc;
    K:=Tree^.Head;
    Leaf(T1);
    B:=Need;
    K:=Tree^.Tail;
    Leaf(T2);
    Need:=Need or B;
    Ref:=GetFunc(Tree^.What)
   end;

   opDoubleVar..opVar:begin
    with PHashCell(Tree^.WhatR)^ do
     If (InWhile<>0) and not (TermType in [opDoubleVar,opVar]) then begin
      CellType:=opPar;
      T1:=@Value;
      Need:=True
     end
     else begin
      CellType:=opConst;
      Result:=Value;
      Need:=False
     end
   end;

   opArrayVar,opPolinom,opStrArrVar:begin
    CellType:=opFunc;
    K:=Tree^.Head;
    Leaf(T1);
    T2:=PHashCell(Tree^.WhatR)^.WhatD; { PStructDef }
    If Op=opPolinom then Ref:=CalcPolinomAddres
    else
     If Tree^.Tail=nil then
      If Op=opStrArrVar then Ref:=@fCalcStrArray
      else Ref:=@fCalcArray { 饭   - }
     else begin { 饭   2-୮ - }
      K:=Tree^.Tail;
      Leaf(Aux);
      Ref:=@fCalcMatrix
     end;
    Need:=True
   end;

   opDirectFunc,opDirectStrFunc,opDirectProc:begin
    P:=PFunction(PHashCell(Tree^.WhatR)^.WhatD);
    FF:=PFuncFacts(Tree^.Head);
    { 맮 - }
    CellType:=opFunc;
    Ref:=@fCalcDirectSubr;
    MaySimple:=False;
    Need:=True;
    T1:=P^.FuncCalc; { PDirectCall }
    If Op=opDirectStrFunc then ResultP:=CurCompilator^.NewMem(TextTermSize);

    With PDirectCall(P^.FuncCalc)^ do begin
     { ।塞 TCallPrepare }
     J:=(PrepareSize+AfterPrepare)*SizeOf(TCallPrepare);
     T2:=CurCompilator^.NewMem(J);
     FastMove(TemplatePrep^,T2^,J);

    For N:=1 to P^.NPars do
     with PCallPrepares(T2)^[N-1] do begin
      Op1:=P^.Pars[N].TermType;
      Case Op1 of
       opVar:begin
        From:=@CalcStack^[Calcs+1].Result;
        {  । - }
        BuildCalcStack(FF^[N].FTree,B);
       end;
       opPar:begin
        Q:=@PHashCell(FF^[N].FTree)^.Value;
        If longint(From)<>-1 then PCallPrepares(T2)^[longint(From)].From:=Q;
        From:=Q
       end;
       opStringVar:begin
        M:=Calcs+1;
        BuildCalcStack(FF^[N].FTree,B);
        From:=CalcStack^[M].ResultP;
       end;
       opStringPar:From:=PHashCell(FF^[N].FTree)^.ValueP;
       opArrayVar..opStrArrVar,opAnyArrVar: { @Data 䠪- ᨢ/ }
        From:=@PStructDef(PHashCell(FF^[N].FTree)^.WhatD)^.Data;
      end;
     end;
    {   ப }
     case Op of
      opDirectFunc:
       with PCallPrepares(T2)^[PrepareSize+AfterPrepare-1] do From:=@Result;
      opDirectStrFunc: with PCallPrepares(T2)^[P^.NPars] do From:=ResultP;
     end
    end;
   end;

   opParProc..opStringFunc,opUserProc:begin
    P:=PFunction(PHashCell(Tree^.WhatR)^.WhatD);
    FF:=PFuncFacts(Tree^.Head);
    J:=Calcs;
    { ⠢塞    - ६-뫮 }
    Inc(Calcs, P^.NParVars{+FF^[0].LocY});

    Case Op of
     opParProc,opUserProc:;
     else begin
      { । १ - }
      CellType:=opPar;
      Inc(J);
      { ⠢塞    - - }
      Inc(Calcs);
      T1:=@CalcStack^[Calcs].Result;
     end
    end;

    { 맮 - }
    With CalcStack^[Calcs] do begin
     CellType:=opFunc;
     Case Op of
      opParFunc:begin
       T1:=P; Ref:=@fCalcUserParFunc
      end;
      opParProc:begin
       T1:=P; Ref:=@fCalcUserParProc
      end;
      else begin
       T1:=P^.FuncCalc;  { PCalcer }
       T2:=@P^.FuncName^.Value;
       Case Op of
        opStringFunc:begin
         Ref:=@fCalcStringFunc;
         ResultP:=CurCompilator^.NewMem(TextTermSize);
        end;
        opUserProc: Ref:=@fCalcUserProc;
        else Ref:=@fCalcUserFunc
       end
      end
     end;
     MaySimple:=False
    end;

    M:=Calcs; { M 㪠-  祩 맮 - }
    If P^.NPars<>0 then Inc(Calcs,P^.NPars+FF^[0].LocX);
    {  P^.NPars=0 FF  । }
    L:=Calcs;
    { M+1..M+NPars = 祩  । 祭 䠪.㬥⮢  - }
    { Calcs+1...   = 祩   祭 䠪. -  - }

    For N:=1 to P^.NPars do begin
     Inc(M);
     Op1:=P^.Pars[N].TermType;

     Case Op1 of
      opVar,opStringVar: {  祭 }
      With CalcStack^[M] do begin
       { । - }
       CellType:=opFunc;
       { T1 - 㤠 । - - }
       If (Op=opParFunc) or (Op=opParProc) then begin
        {  ---   ⭮,   ᠬ
        । - -,    ,
           -   }
        T1:=@P^.Pars[N].Hash;
        Ref:=@fMailPar
       end
       else begin
        T1:=@P^.Pars[N].Hash^.Value;
        If Op1=opVar then Ref:=@fPopParAddres else Ref:=@fPopString
       end;
       { T2 -  । }
       T2:=@CalcStack^[Calcs+1].Result;
       MaySimple:=False;
       {  । - }
       BuildCalcStack(FF^[N].FTree,B);
      end;

      opPar,opStringPar:begin {  뫪 }
       { । - -  - }
       With CalcStack^[M] do begin
        CellType:=opFunc;
        If (Op=opParFunc) or (Op=opParProc) then begin
         T1:=@P^.Pars[N].Hash;
         Ref:=@fMailPar
        end
        else begin
         T1:=@P^.Pars[N].Hash^.Value;
         If Op1=opPar then Ref:=@fPopParAddres else Ref:=@fPopString
        end;
        T2:=@PHashCell(FF^[N].FTree)^.Value;
        MaySimple:=False;
       end;
       {  - - }
       With CalcStack^[J] do begin
        CellType:=opFunc;
        If Op=opParFunc then Ref:=@fMailPar
        else
         If Op1=opPar then Ref:=@fPopParAddres else Ref:=@fPopString;
        T1:=CalcStack^[M].T2; { 㤠  - }
        T2:=CalcStack^[M].T1; {   }
        MaySimple:=False;
       end;
       Inc(J)
      end;

      opArrayVar..opStrArrVar,opAnyArrVar:
       With CalcStack^[M] do begin
        CellType:=opFunc;
        If (Op=opParFunc) or (Op=opParProc) then begin
         T1:=@P^.Pars[N].Hash;
         Ref:=@fMailStruct
        end
        else begin
         { 㤠 । =  - Data}
         T1:=@PStructDef(P^.Pars[N].Hash^.WhatD)^.Data;
         Ref:=@fMailAddres;
        end;
        {  ।: @Data 䠪- ᨢ/ }
        T2:=@PStructDef(PHashCell(FF^[N].FTree)^.WhatD)^.Data;
        MaySimple:=False;
       end;

      opUserFunc,opUserProc:
       With CalcStack^[M] do begin
        CellType:=opFunc;
        { 㤠 । =  - PFunction }
        T1:=PFunction(P^.Pars[N].Hash^.WhatD);
        {  । =  䠪. PFunction }
        T2:=PHashCell(FF^[N].FTree)^.WhatD;
        Ref:=@fMailPFunction; { ४稢 TFunction }
        MaySimple:=False;
       end;

      opUserVar1..opUserVar2:begin
       { । - }
       With CalcStack^[M] do begin
        CellType:=opFunc;
        T1:=@P^.Pars[N].Hash^.Value;
        T2:=@PHashCell(FF^[N].FTree)^.Value;
        Ref:=@fPopTen;
        MaySimple:=False;
       end;
       If P^.Pars[N].UTFlag and utfByPar<>0 then
        {  - - }
        With CalcStack^[J] do begin
         CellType:=opFunc;
         Ref:=@fPopTen;
         T1:=CalcStack^[M].T2; { 㤠  - }
         T2:=CalcStack^[M].T1; {   }
         MaySimple:=False;
         Inc(J)
        end
      end;

      opMultiVar:begin
       Q:=pointer(FF^[N].FTree);
       { - -  ᯨ᮪ । ࠭ -ࠬ஢ }
       With CalcStack^[L] do begin
        CellType:=opFunc;
        T1:=P^.FuncCalc;
        T2:=pointer(N);
        Ref:=@fCalcClearMultiList;
        MaySimple:=False;
       end;
       Dec(M);
       r:=0;
       While Q<>nil do begin { 横  䠪᪨ । - }
        Inc(M);
        With CalcStack^[M] do begin
         MaySimple:=False;
         { । 祭 }
         CellType:=opFunc;
         longint(Aux):=longint(Q^.WhatExpr);
         { 㤠 । }
         T1:=P^.Pars[N].Hash^.WhatD; { TCollection -ࠬ஢ }
         Ref:=@fPopMParAddres;
         {  । }
         If Q^.WhatExpr=wmpArrayMultiPar then { @Data 䠪- ᨢ/ }
          T2:=@PStructDef(PHashCell(Q^.Expr)^.WhatD)^.Data
         else
          If (Q^.WhatExpr>=wmpUserType1) and (Q^.WhatExpr<=wmpUserType2) then begin
           T2:=@PHashCell(Q^.Expr)^.Value;
           If Q^.ByValue then longint(Aux):=longint(Aux) or $8000
          end
          else
          If Q^.ByValue then begin
           T2:=@CalcStack^[Calcs+1].Result;
           {  । - }
           BuildCalcStack(Q^.Expr,B)
          end
          else begin
           T2:=@PHashCell(Q^.Expr)^.Value;
           longint(Aux):=longint(Aux) or $8000;
          end
        end;
        Q:=Q^.Prev;
       end;
      end;
     end {case }
    end; { for }
    Need:=True
   end;

   opPar,opUknown:begin
    { T1 = PFloat }
    CellType:=opPar;
    T1:=@PHashCell(Tree^.WhatR)^.Value;
    Need:=True
   end;

   opStringConst:begin
    CellType:=opConst;
    ResultP:=Tree^.WhatR; { ResultP = PText }
    Need:=False
   end;

   opStringVar..opStringDouble:begin
    CellType:=opConst;
    with PHashCell(Tree^.WhatR)^ do begin
     If (InWhile<>0) and (TermType=opStringPar) then Need:=True
     else Need:=False;
     ResultP:=ValueP; { ResultP = PText }
    end
   end;

   opStringPar:begin
    CellType:=opConst;
    with PHashCell(Tree^.WhatR)^ do ResultP:=ValueP; { ResultP = PText }
    Need:=True
   end;

   opStrConcat:begin  { ⥭ ப }
    CellType:=opFunc;
    K:=Tree^.Head;
    Leaf(T1);
    B:=Need;
    K:=Tree^.Tail;
    Leaf(T2);
    Need:=Need or B;
    Ref:=@fStrConcat;
    ResultP:=CurCompilator^.NewMem(TextTermSize);
   end;
  end; { case }
  MaySimple:=not Need
 end
End;

Procedure TExpressionCalcer.Evaluate;
Var I:word;
Begin
 I:=Calcs;
 Repeat
  With CalcStack^[I] do
   Case CellType of
    opPar  : FastMoveWord(T1^,Result,5);
    opFunc : TCalcFunc(Ref)(CalcStack^[I]);
   end;
  Dec(I)
 until I=0
End;

Procedure TExpressionCalcer.Simplify;
Var I:word;
Begin
 I:=Calcs;
 Repeat
  With CalcStack^[I] do
   { ᫨ -  饭  ⨯ 樨=opFunc - - }
   If MaySimple and (CellType=opFunc) then begin
    TCalcFunc(Ref)(CalcStack^[I]);
    CellType:=opConst
   end;
  Dec(I)
 until I=0
End;

Constructor TFormulaCalcer.Init(F:PFormula);
Begin
 Inherited Init(F^.E);
 LHash:=F^.Loc;        {  ६    }
 ResAd:=@LHash^.Value; { 㤠  - - }
 If Simplify then Fail { 頥 }
End;

Procedure TFormulaCalcer.Evaluate;
Begin
 Inherited Evaluate;
 { १- -   ६ }
 ResAd^:=CalcStack^[1].Result;
End;

Function TFormulaCalcer.Simplify:boolean;
Begin
 Simplify:=False;
 If not ENeed then begin
  Evaluate;
  { ᫨    - - ६-⠭,  㤠塞 ꥪ }
  If (LHash^.TermType=opVar) then begin
   Done;
   Simplify:=True
  end
 end
End;

Constructor TFuncPropCalcer.Init(F:PPropFormula; FloatFunc:boolean);
Begin
 Inherited Init(F^.RValue);
 FR:=New(PExpressionCalcer, Init(F^.LValue));
 LHash:=F^.Loc;        {  ६    }
 FR^.CalcStack^[1].CellType:=opConst; {  -  }
 With FR^.CalcStack^[F^.Func^.NParVars+2] do begin
  T1:=F^.Func^.FuncCalc;
  Ref:=@fAssignPropValue;
  If FloatFunc then T2:=@CalcStack^[1].Result else T2:=CalcStack^[1].ResultP;
 end;
End;

Procedure TFuncPropCalcer.Evaluate;
Begin
 Inherited Evaluate;
 FR^.Evaluate;
End;

Destructor TFuncPropCalcer.Done;
Begin
 Dispose(FR,Done);
 Inherited Done
End;

Procedure TAssignFuncCalcer.Evaluate;
Begin
 Inherited Evaluate;
 PUserFunc(PFunction(LHash^.WhatD)^.FuncCalc)^.AssignValue(ResAd)
End;

Procedure TAssignStrFuncCalcer.Evaluate;
Begin
 Inherited Evaluate;
 PUserFunc(PFunction(LHash^.WhatD)^.FuncCalc)^.AssignValue(StrAd)
End;

Constructor TStrFormulaCalcer.Init(F:PFormula);
Begin
 Inherited Init(F^.E);
 LHash:=F^.Loc;        {  ६    }
 StrAd:=LHash^.ValueP; { 㤠  - - }
 If Simplify then Fail { 頥 }
End;

Function TStrFormulaCalcer.Simplify:boolean;
Begin
 Simplify:=False;
 If not ENeed then begin
  Evaluate;
  { ᫨    - - ६-⠭,  㤠塞 ꥪ }
  If (LHash^.TermType=opStringVar) then begin
   Done;
   Simplify:=True
  end
 end
End;

Procedure TStrFormulaCalcer.Evaluate;
Begin
 Inherited Evaluate;
 { १- -   ६ }
 StrAd^:=CalcStack^[1].ResultP^;
End;

Constructor TUTFormulaCalcer.Init(F:PUserTypeFormula);
begin
 Inherited Init;
 Hashes:=F^
end;

Procedure TUTFormulaCalcer.Evaluate;
begin
 with Hashes do FastMoveWord(LocR^.Value,LocL^.Value,5);
end;

Constructor TArrayCalcer.Init(F:PArrayCell);
Begin
 With F^ do begin
  MC:=@PStructDef(Loc^.WhatD)^.Data;   { ^PMatrix }
  IndexC:=New(PExpressionCalcer, Init(Index));
  ValC:=New(PExpressionCalcer, Init(FTree))
 end
End;

Procedure TArrayCalcer.Evaluate;
Type PM=^PMatrix;
Var L:word;
Begin
 L:=Round(IndexC^.Calculate^);
 PM(MC)^^.Put(L, ValC^.Calculate)
End;

Destructor TArrayCalcer.Done;
Begin
 Dispose(IndexC, Done);
 Dispose(ValC, Done)
End;

Constructor TStrArrayCalcer.Init(F:PArrayCell);
Begin
 With F^ do begin
  MC:=@PStructDef(Loc^.WhatD)^.Data; { ^PMatrix }
  IndexC:=New(PExpressionCalcer, Init(Index));
  ValC:=New(PStrExpressionCalcer, Init(FTree))
 end
End;

Constructor TMatrixCalcer.Init(F:PArrayCell);
Begin
 Inherited Init(F);
 Index2C:=New(PExpressionCalcer, Init(F^.Index2));
End;

Procedure TMatrixCalcer.Evaluate;
Type PM=^PMatrixF;
Var L1,L2:word;
Begin
 L1:=Round(IndexC^.Calculate^);
 L2:=Round(Index2C^.Calculate^);
 PM(MC)^^.Put2(L1,L2, ValC^.Calculate)
End;

Destructor TMatrixCalcer.Done;
Begin
 Dispose(Index2C, Done);
 Inherited Done
End;

Constructor TLogicCalcer.Init(ACalcs:word; Tree:PLogicTree);
Begin
 GetMem(CalcStack, ACalcs*SizeOf(TCalcCell));
 Calcs:=0;
 BuildCalcStack(Tree)
End;

Procedure TLogicCalcer.BuildCalcStack(Tree:PLogicTree);
Var Op:OpsType;
Begin
 Inc(Calcs);
 With CalcStack^[Calcs] do begin
  Op:=Tree^.What;
  CellType:=Op;

  Case Op of
   etBool: { - ࠢ }
    With PBoolExpression(Tree^.Left)^ do begin
     T1:=New(PExpressionCalcer, Init(Left));
     T2:=New(PExpressionCalcer, Init(Right));
     Ref:=GetBoolFunc(What)
    end;

   etCompFunc:
    with Tree^ do begin
     T1:=New(PExpressionCalcer, Init(PExpression(Left)^));
     Ref:=GetBoolFunc(LogicOp)
    end;

   else { etLogic, .  }
    With Tree^ do begin
     T1:=@CalcStack^[Calcs+1].ResultB;
     BuildCalcStack(Left);
     If LogicOp<>ltNot then begin
      T2:=@CalcStack^[Calcs+1].ResultB;
      BuildCalcStack(Right)
     end;
     Ref:=GetLogicFunc(LogicOp)
    end
  end; { case }
 end
End;

Procedure TLogicCalcer.Evaluate;
Var I:word;
Begin
 For I:=Calcs downto 1 do
  With CalcStack^[I] do TCalcFunc(Ref)(CalcStack^[I]);
End;

Function TLogicCalcer.CalculateB:boolean;
Begin
 Evaluate;
 CalculateB:=CalcStack^[1].ResultB
End;

Destructor TLogicCalcer.Done;
Var I:word;
Begin
 For I:=1 to Calcs do
  With CalcStack^[I] do
   Case CellType of
    etBool:begin
     Dispose(PExpressionCalcer(T1),Done);
     Dispose(PExpressionCalcer(T2),Done)
    end;
    etCompFunc: Dispose(PExpressionCalcer(T1),Done);
   end;
 FreeMem(CalcStack, Calcs*SizeOf(TCalcCell));
End;

Constructor TIfCalcer.Init(P:PIfCycle);
Begin
 Condition:=New(PLogicCalcer, Init(P^.LogCalcs,P^.Logic)); { ᫮ }
 BodyIf:=New(PBlockCalcer, Init(P^.BListIf,False)); { .  }
 If P^.BListElse=nil then BodyElse:=nil
 else {  Else }
  BodyElse:=New(PBlockCalcer, Init(P^.BListElse,False))
End;

Procedure TIfCalcer.Evaluate;
Begin
 If Condition^.CalculateB then BodyIf^.Evaluate
 else
  If BodyElse<>nil then BodyElse^.Evaluate
End;

Destructor TIfCalcer.Done;
Begin
 Dispose(Condition, Done);
 Dispose(BodyIf, Done);
 If BodyElse<>nil then Dispose(BodyElse, Done)
End;

Constructor TWhileCalcer.Init(P:PWhileCycle);
Begin
 Inc(InWhile); {   - While }
 Condition:=New(PLogicCalcer, Init(P^.LogCalcs,P^.Logic)); { ᫮ }
 Body:=New(PBlockCalcer, Init(P^.BList,False)); { ⥫ 横 }
 Dec(InWhile);
End;

Procedure TWhileCalcer.Evaluate;
Begin
 CalcBreakState:=0;
 {  - ᫮   뫮 -஢ Break  Exit }
 While Condition^.CalculateB and (CalcBreakState and (BreakBit+ExitBit) =0) do
 begin
   asm
    mov ax,CalcBreakState
    test ax,ContinueBit   { ᫨   - Continue, }
    je @out               { 뢠 ᮮ-騩   CalcBreakState }
    and ax,not ContinueBit
    mov CalcBreakState,ax
@out:
   end;
   Body^.Evaluate
 end;
 { 頥  䫠 ஬ Exit }
 CalcBreakState:=CalcBreakState and ExitBit
End;

Destructor TWhileCalcer.Done;
Begin
 Dispose(Condition, Done);
 Dispose(Body, Done);
End;

Constructor TBCECalcer.Init(AWhat:TRunBreak);
Begin
 What:=AWhat;
End;

Procedure TBCECalcer.Evaluate;
Begin
 case What of
  rbBreak:    CalcBreakState:=CalcBreakState or BreakBit;
  rbContinue: CalcBreakState:=CalcBreakState or ContinueBit;
  rbExit:     CalcBreakState:=CalcBreakState or (ExitBit+BreakBit);
 end
End;

Constructor TBlockCalcer.Init(B:PBlockList; AGlobal:boolean);
Var I,J,K,BlocksCount:word; P:PBlockList; F:PFormulaCalcer;
Begin
 Global:=AGlobal;
 J:=1;
 First:=1;

 With B^ do begin
  Count:=NBlocks;
  If not AGlobal then begin
   Inc(J, NStructDefs);
   Inc(Count, NStructDefs*2)
  end;
  BlocksCount:=NBlocks+NDefBlocks+J;
 end;
 Last:=Count;
 Calcs:=Count;

 GetMem(Operators, Count*SizeOf(pointer));
 FillChar(Operators^, Count*SizeOf(pointer), 0);

 P:=B^.Next;
 I:=J-1;
 K:=0;

 While J<BlocksCount do begin
   If CompError.Error<>0 then exit;
   Inc(I); Inc(J);
   Case P^.What of
    etFormula: begin
     F:=New(PFormulaCalcer, Init(P^.Expr));
     If F<>nil then Operators^[I]:=F
     else begin
      Dec(I); Inc(K)
     end
    end;
    etArrayCell:
     If PArrayCell(P^.Expr)^.Index2.FTree=nil then
      Operators^[I]:=New(PArrayCalcer, Init(P^.Expr))
     else
      Operators^[I]:=New(PMatrixCalcer, Init(P^.Expr));
    etIf:            Operators^[I]:=New(PIfCalcer, Init(P^.Expr));
    etWhile:         Operators^[I]:=New(PWhileCalcer, Init(P^.Expr));
    etStrArrayCell:  Operators^[I]:=New(PStrArrayCalcer, Init(P^.Expr));
    etProc:          Operators^[I]:=New(PProcCalcer, Init(PExpression(P^.Expr)^));
    etBreak:         Operators^[I]:=New(PBCECalcer, Init(rbBreak));
    etContinue:      Operators^[I]:=New(PBCECalcer, Init(rbContinue));
    etExit:          Operators^[I]:=New(PBCECalcer, Init(rbExit));
    etArrayDef:      If CompileArrayDef(P^.Expr) then Dec(I) else exit;
    etFuncDef,
    etProcDef:       If CompileFuncDef(P) then Dec(I) else exit;
    etStrFormula: begin
     PStrFormulaCalcer(F):=New(PStrFormulaCalcer, Init(P^.Expr));
     If F<>nil then Operators^[I]:=F
     else begin
      Dec(I); Inc(K)
     end
    end;
    etPrint:         Operators^[I]:=New(PPrintCalcer, Init(P^.Expr));
    etAssignFunc:    Operators^[I]:=New(PAssignFuncCalcer, Init(P^.Expr));
    etAssignStrFunc: Operators^[I]:=New(PAssignStrFuncCalcer, Init(P^.Expr));
    etFuncProp,etStrFuncProp:
     Operators^[I]:=New(PFuncPropCalcer, Init(P^.Expr,P^.What=etFuncProp));
    etUserTypeFormula: Operators^[I]:=New(PUTFormulaCalcer,Init(P^.Expr));
   end;
   P:=P^.Next
 end;

 If I<>Last then begin
  FastMoveWord(Operators^[Last+1], Operators^[I+1],(Count-Last)*(SizeOf(pointer) div 2));
  Dec(Calcs,K)
 end;
 Last:=Calcs+1-B^.NStructDefs
End;

Function TBlockCalcer.CompileFuncDef(PBL:PBlockList):boolean;
Var P:PFunction; BL:PBlockList; F:PBlockCalcer;
Begin
 P:=PBL^.Expr;
 BL:=PBlockList(P^.FuncCalc);
 {  ⥪ - }
 F:=New(PUserFuncCalcer, Init(BL,False));
 P^.FuncCalc:=F;
 DefColl^.Insert(F);
 CompileFuncDef:=CompError.Error=0
End;

Function TBlockCalcer.CompileArrayDef(PS:PStructDef):boolean;
Const maxword=$FFF0;
Var P:PExpressionCalcer; S:extended; Lines,Cols,I,J:word; M:PMatrix; Q:PCellList;

 Function GetDim(Const Sz:TExpression; Var Dim:word):boolean;
 Begin
  P:=New(PExpressionCalcer, Init(Sz));
  S:=P^.Calculate^;
  Dispose(P, Done);
  If NotNumber(S) or (S<1) or (S>maxword) then
   With CompError,Sz do begin
    Error:=teInvArraySize;
    cX:=LocX; cY:=LocY;
    GetDim:=False;
    exit
   end;
  Dim:=Round(S);
  GetDim:=True
 end;

Begin
 CompileArrayDef:=False;

 With PS^ do begin
  { - ᫮ ப }
  If not GetDim(SizeVal, Lines) then exit;
  If Size2Val.FTree<>nil then begin { - ᫮ ⮫殢 }
   If not GetDim(Size2Val, Cols) then exit
   else
    If (MType<>GeneralM) and (Lines<>Cols) then
     With CompError,Size2Val do begin
      Error:=teDimNotEqual; cX:=LocX; cY:=LocY; exit
     end
  end
  else
   If MType and (GeneralM+StringM)<>0 then Cols:=1 else Cols:=Lines;

  If not Extern then
   If Global then begin { ᠭ -  . ணࠬ }
    Case MType of
     GeneralM: M:=New(PHeapMatrixFG, Init(Lines,Cols));
     SimmM   : M:=New(PHeapMatrixFS, Init(Lines,Cols));
     DiagM   : M:=New(PHeapMatrixFD, Init(Lines,Cols));
     StringM : M:=New(PStrMatrix, Init(Lines,longint(Data)));
    end;
    DefColl^.Insert(M);
    J:=M^.Loc(Lines,Cols);
    Data:=M;
    Q:=CellList;

    For I:=1 to Cells do begin { - . - }
     If I>J then
      With CompError,Q^.F do begin
       Error:=teTooManyCells; cX:=LocX; cY:=LocY; exit
      end;

     Q:=Q^.Next;
     If MType=StringM then begin
      P:=New(PStrExpressionCalcer, Init(Q^.F));
      PStrMatrix(M)^.Put(I,Pstring(P^.Calculate));
      Dispose(P,Done)
     end
     else begin
      P:=New(PExpressionCalcer, Init(Q^.F));
      M^.Put(I,P^.Calculate);
      Dispose(P,Done)
     end;
    end;
    { ᫨ ᫮ . -  ࠧ, 㡫- ᫥ -   ⠢訥 }
    If (Cells>0) and (J>Cells) and (MType<>StringM) then M^.Fill(Cells+1,J,S)
   end
   else begin
    If MType=StringM then Cols:=longint(Data);
    Operators^[First]:=New(PMatrixAlloc, Init(Lines,Cols,PS));
    Inc(First);
    Operators^[Last]:=New(PMatrixDeAlloc, Init(PS));
    Dec(Last)
   end
 end;
 CompileArrayDef:=True
End;

Procedure TBlockCalcer.Evaluate;
Var CurBlock:word;
Begin
 CurBlock:=1;
 While (CurBlock<=Calcs) and (CalcBreakState=0) do begin
  Operators^[CurBlock]^.Evaluate;
  Inc(CurBlock)
 end;
End;

Destructor TBlockCalcer.Done;
Var I:word;
Begin
 For I:=1 to Calcs do
  If Operators^[I]<>nil then Dispose(Operators^[I], Done);
 FreeMem(Operators, Count*SizeOf(pointer));
End;

Procedure TUserFuncCalcer.Evaluate;
Var I:word;
Begin
 Inherited Evaluate;
 If CalcBreakState and ExitBit<>0 then
  For I:=Calcs downto Last do Operators^[I]^.Evaluate;
 CalcBreakState:=0
End;

Constructor TMatrixAlloc.Init(ALines,ACols:word; P:PStructDef);
Begin
 Lines:=ALines;
 Cols:=ACols;
 MType:=P^.MType;
 PData:=@P^.Data;
 Ppointer(PData)^:=nil
End;

Procedure TMatrixAlloc.Evaluate;
Var A:pointer;
Begin
 Case MType of
  GeneralM: A:=New(PHeapMatrixFG, Init(Lines,Cols));
  SimmM   : A:=New(PHeapMatrixFS, Init(Lines,Cols));
  DiagM   : A:=New(PHeapMatrixFD, Init(Lines,Cols));
  StringM : A:=New(PStrMatrix, Init(Lines,Cols));
 end;
 Ppointer(PData)^:=A
End;

Destructor TMatrixAlloc.Done;
Begin
 If Ppointer(PData)^<>nil then Dispose(PMatrix(Ppointer(PData)^), Done)
End;

Constructor TMatrixDeAlloc.Init(P:PStructDef);
Begin
 PData:=@P^.Data;
End;

Procedure TMatrixDeAlloc.Evaluate;
Begin
 If Ppointer(PData)^<>nil then begin
  Dispose(PMatrix(Ppointer(PData)^), Done);
  Ppointer(PData)^:=nil
 end
End;

Constructor TPrintCalcer.Init(B:PBlockList);
Var I:word;
Begin
 Count:=B^.NBlocks+1;
 GetMem(Operators, Count*SizeOf(pointer));
 FillChar(Operators^, Count*SizeOf(pointer), 0);

 Operators^[Count]:=New(PFlushLine,Init);
 For I:=1 to Count-1 do begin
  B:=B^.Next;
  Case B^.What of
   etFormula:    Operators^[I]:=New(PExpressionPrint, Init(B^.Expr));
   etStrFormula: Operators^[I]:=New(PStrFormulaPrint, Init(B^.Expr));
  end
 end;
End;

Procedure TPrintCalcer.Evaluate;
Var I:word;
Begin
 For I:=1 to Count do Operators^[I]^.Evaluate
End;

Destructor TPrintCalcer.Done;
Var I:word;
Begin
 For I:=1 to Count do
  If Operators^[I]<>nil then Dispose(Operators^[I], Done);
 FreeMem(Operators, Count*SizeOf(pointer));
End;

Constructor TFlushLine.Init;
Begin
 Inherited Init;
 Compiler:=PCalcer(CurCompilator)
End;

Procedure TFlushLine.Evaluate;
Begin
 PACompilator(Compiler)^.FlushPrintLine
End;

Constructor TExpressionPrint.Init(F:PPrintRec);
Begin
 Inherited Init;
 PE:=New(PExpressionCalcer, Init(F^.F));
 With F^ do begin
  TeF1:=F1; TeF2:=F2; TeExp:=Expo
 end;
End;

Procedure TExpressionPrint.Evaluate;
Var R:Float; S:string;
Begin
 R:=PE^.Calculate^;
 If NotNumber(R) then
  If not TeExp and (TeF2=0) then S:='?' else S:=LPad('?',TeF1)
 else
  If TeExp then Str(R:TeF1,S) else Str(R:TeF1:TeF2,S);
 PACompilator(Compiler)^.Print(S)
End;

Destructor TExpressionPrint.Done;
Begin
 If PE<>nil then Dispose(PE, Done)
End;

Constructor TStrFormulaPrint.Init(F:PPrintRec);
Begin
 Inherited Init;
 PS:=New(PExpressionCalcer, Init(F^.F));
End;

Procedure TStrFormulaPrint.Evaluate;
Begin
 PS^.Evaluate;
 PACompilator(Compiler)^.Print(PS^.CalcStack^[1].ResultP^)
End;

Destructor TStrFormulaPrint.Done;
Begin
 If PS<>nil then Dispose(PS, Done)
End;

Procedure TACompilator.Print(Var S:string);
Begin End;

Procedure TACompilator.FlushPrintLine;
Begin End;

Procedure TACompilator.ReadyPrint;
Begin End;

Function TACompilator.NewMem(Size:word):pointer;
Var P:PByteA; Q:PointersList; I:word;
Begin
 GetMem(P,Size);
 Inc(FreeIndex);
 If FreeIndex>FreeSize then begin
  I:=FreeSize;
  Inc(FreeSize,PointerInc);
  GetMem(Q,FreeSize*SizeOf(PointerRec));
  FastMove(Pointers^,Q^,I*SizeOf(PointerRec));
  FreeMem(Pointers,I*SizeOf(PointerRec));
  Pointers:=Q
 end;
 Pointers^[FreeIndex].P:=P;
 Pointers^[FreeIndex].Size:=Size;
 NewMem:=P
End;

Function TACompilator.NewMemTmp(Size:word):pointer;
Var P:PByteA; Q:PointersList; I:word;
Begin
 GetMem(P,Size);
 Inc(FreeIndexTmp);
 If FreeIndexTmp>FreeSizeTmp then begin
  I:=FreeSizeTmp;
  Inc(FreeSizeTmp,PointerInc);
  GetMem(Q,FreeSizeTmp*SizeOf(PointerRec));
  FastMove(PointersTmp^,Q^,I*SizeOf(PointerRec));
  FreeMem(PointersTmp,I*SizeOf(PointerRec));
  PointersTmp:=Q
 end;
 PointersTmp^[FreeIndexTmp].P:=P;
 PointersTmp^[FreeIndexTmp].Size:=Size;
 NewMemTmp:=P
End;

Procedure TACompilator.DisposeMem(Index:word);
Var I:word;
Begin
 For I:=Index+1 to FreeIndex do FreeMem(Pointers^[I].P, Pointers^[I].Size);
 FreeIndex:=Index
End;

Procedure TACompilator.DisposeMemTmp(Index:word);
Var I:word;
Begin
 For I:=Index+1 to FreeIndexTmp do FreeMem(PointersTmp^[I].P, PointersTmp^[I].Size);
 FreeIndexTmp:=Index
End;

Constructor TACompilator.Init;
Begin
 Inherited Init;
 FreeSize:=PointerInc;
 FreeIndex:=0;
 FreeSizeTmp:=PointerInc;
 FreeIndexTmp:=0;
 GetMem(Pointers,FreeSize*SizeOf(PointerRec));
 GetMem(PointersTmp,FreeSizeTmp*SizeOf(PointerRec));
End;

Function TACompilator.GetFuncAdres(What:word):pointer;
Begin End;

Destructor TACompilator.Done;
Begin
 DisposeMem(0);
 DisposeMemTmp(0);
 FreeMem(Pointers,FreeSize*SizeOf(PointerRec));
 FreeMem(PointersTmp,FreeSizeTmp*SizeOf(PointerRec));
 Inherited Done;
End;

Procedure ValidName(Var Name:string; Var Error:integer; Var ErrorPos:word);
Begin
 If Length(Name)>MaxTermLen then begin
  Error:=teInvNameLen; ErrorPos:=1; exit
 end;
 If IsNumber(Name[1]) then begin
  Error:=teFirstNumber; ErrorPos:=1; exit
 end;
 ErrorPos:=GetHashKey(Name);
 If ErrorPos<>0 then Error:=teIncorrectChar else Error:=0
End;

End.
