{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit Hash2x2; {   }
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses Calcer,X1,Def2x2,Objects;

Type

 AHash=array[0..MaxHashKey-1] of PHashCell; { -⠡ }

 PTermHash=^TTermHash;
 TTermHash=object(TObject)   {  ମ }
  Prev:PTermHash;            {  ।饣 ஢ }
  Owner:PACompilator;        { ,   }
  Hash:AHash;                { -⠡ }
  constructor Init(AOwner:PACompilator; APrev:PTermHash);
  function Search(Const N:string; MakeItem:boolean; TypeMask:word;
   Var H:PHashCell):boolean;
 end;

 PStandardHash=^TStandardHash;
 TStandardHash=object(TTermHash)  {  १. ᫮ }
  constructor Init(AOwner:PACompilator; APrev:PTermHash);
  function Find(Const N:string; Var H:PHashCell):boolean;
  procedure RegisterRW(RW:PResWords; Nums:word);
 end;

Implementation

Constructor TTermHash.Init(AOwner:PACompilator; APrev:PTermHash);
Begin
 Owner:=AOwner;
 Prev:=APrev;
 FillChar(Hash,MaxHashKey*SizeOf(pointer),0)
End;

Function TTermHash.Search(Const N:string; MakeItem:boolean;
                          TypeMask:word; Var H:PHashCell):boolean;
{   N  . TypeMask -, । -   ⨯
  ᪠ - ।  (AllMask)  ⮫쪮 ।  - (FuncMask).
  ᫨   ,   ।  - (TypeMask=FuncMask)
    ᮪ ஢ (Prev). ᫨  ⠬   
  MakeItem=True,  ᮧ-  -  }
Var K:PHashCell;
Begin
 H:=Hash[CurHashKey];
 K:=H;
 While H<>nil do begin
  If H^.HVal^.TermType and TypeMask=H^.HVal^.TermType then
   If H^.HVal^.Name=N then begin
    Search:=True; H:=H^.HVal; exit
   end;
  K:=H;
  H:=H^.Next
 end;

 If Prev<>nil then
  If Prev^.Search(N,False,FuncMask,H) then begin
   Search:=True; exit
  end;

 If MakeItem then begin
  H:=Owner^.NewMem(SizeOf(THashCell));
  H^.Next:=nil;
  H^.Name:=N;
  {H^.InUse:=0;}
  If K=nil then Hash[CurHashKey]:=H else K^.Next:=H;
  H^.HVal:=H
 end;
 Search:=False
End;

Function TStandardHash.Find(Const N:string; Var H:PHashCell):boolean;
{ 頥 True, ᫨  N - १ࢨ.  }
Begin
 H:=Hash[CurHashKey];
 While H<>nil do begin
  If H^.Name=N then begin
   Find:=True; exit
  end;
  H:=H^.Next
 end;
 Find:=False
End;

Constructor TStandardHash.Init(AOwner:PACompilator; APrev:PTermHash);
Begin
 Inherited Init(AOwner,APrev);
 { ॣ- १.  }
 RegisterRW(@ResWords,MaxResWords);
End;

Procedure TStandardHash.RegisterRW(RW:PResWords; Nums:word);
Var I,H:byte; P,K:PHashCell;
Begin
 For I:=1 to Nums do begin
  H:=RW^[I].Hash;
  If H>=MaxHashKey then continue;
  P:=Owner^.NewMem(SizeOf(THashCell));
  P^.HVal:=P;
  P^.Next:=nil;
  K:=Hash[H];
  If K=nil then Hash[H]:=P
  else begin
   While K^.Next<>nil do K:=K^.Next;
   K^.Next:=P
  end;
  Move(ResWords[I],P^,SizeOf(ResWordType)-1)
 end
End;

End.
